## Vanara.PInvoke.Graphics  
PInvoke API (methods, interfaces, structures and constants) imported from Windows Graphics APIs. Currently supports Windows Imaging Component (WIC), DirectWrite (full), Direct2D (partial), and Direct3D (DXGI only).

- Includes methods from d2d1.dll, dxgi.dll, dwrite.dll, windowscodecs.dll  
- Current NuGet release: [![Nuget](https://img.shields.io/nuget/v/Vanara.PInvoke.Graphics?logo=nuget&style=flat-square)![Nuget](https://img.shields.io/nuget/dt/Vanara.PInvoke.Graphics?label=%20&style=flat-square)](https://www.nuget.org/packages/Vanara.PInvoke.Graphics)  
### Methods - 100% API coverage (25 of 25 functions)  
Native Method | Native DLL | Header | Managed Method  
--- | --- | --- | ---  
[CreateDXGIFactory](https://www.google.com/search?num=5&q=CreateDXGIFactory+site%3Alearn.microsoft.com) | dxgi.dll | dxgi.h | [Vanara.PInvoke.DXGI.CreateDXGIFactory](https://github.com/dahall/Vanara/search?l=C%23&q=CreateDXGIFactory)  
[CreateDXGIFactory1](https://www.google.com/search?num=5&q=CreateDXGIFactory1+site%3Alearn.microsoft.com) | dxgi.dll | dxgi.h | [Vanara.PInvoke.DXGI.CreateDXGIFactory1](https://github.com/dahall/Vanara/search?l=C%23&q=CreateDXGIFactory1)  
[CreateDXGIFactory2](https://www.google.com/search?num=5&q=CreateDXGIFactory2+site%3Alearn.microsoft.com) | dxgi.dll | dxgi1_3.h | [Vanara.PInvoke.DXGI.CreateDXGIFactory2](https://github.com/dahall/Vanara/search?l=C%23&q=CreateDXGIFactory2)  
[D2D1ComputeMaximumScaleFactor](https://www.google.com/search?num=5&q=D2D1ComputeMaximumScaleFactor+site%3Alearn.microsoft.com) | d2d1.dll | d2d1_2.h | [Vanara.PInvoke.D2d1.D2D1ComputeMaximumScaleFactor](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1ComputeMaximumScaleFactor)  
[D2D1ConvertColorSpace](https://www.google.com/search?num=5&q=D2D1ConvertColorSpace+site%3Alearn.microsoft.com) | d2d1.dll | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1ConvertColorSpace](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1ConvertColorSpace)  
[D2D1CreateDevice](https://www.google.com/search?num=5&q=D2D1CreateDevice+site%3Alearn.microsoft.com) | d2d1.dll | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1CreateDevice](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1CreateDevice)  
[D2D1CreateDeviceContext](https://www.google.com/search?num=5&q=D2D1CreateDeviceContext+site%3Alearn.microsoft.com) | d2d1.dll | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1CreateDeviceContext](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1CreateDeviceContext)  
[D2D1CreateFactory](https://www.google.com/search?num=5&q=D2D1CreateFactory+site%3Alearn.microsoft.com) | d2d1.dll | d2d1.h | [Vanara.PInvoke.D2d1.D2D1CreateFactory](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1CreateFactory)  
[D2D1GetGradientMeshInteriorPointsFromCoonsPatch](https://www.google.com/search?num=5&q=D2D1GetGradientMeshInteriorPointsFromCoonsPatch+site%3Alearn.microsoft.com) | d2d1.dll | d2d1_3.h | [Vanara.PInvoke.D2d1.D2D1GetGradientMeshInteriorPointsFromCoonsPatch](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1GetGradientMeshInteriorPointsFromCoonsPatch)  
[D2D1InvertMatrix](https://www.google.com/search?num=5&q=D2D1InvertMatrix+site%3Alearn.microsoft.com) | d2d1.dll | d2d1.h | [Vanara.PInvoke.D2d1.D2D1InvertMatrix](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1InvertMatrix)  
[D2D1IsMatrixInvertible](https://www.google.com/search?num=5&q=D2D1IsMatrixInvertible+site%3Alearn.microsoft.com) | d2d1.dll | d2d1.h | [Vanara.PInvoke.D2d1.D2D1IsMatrixInvertible](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1IsMatrixInvertible)  
[D2D1MakeRotateMatrix](https://www.google.com/search?num=5&q=D2D1MakeRotateMatrix+site%3Alearn.microsoft.com) | d2d1.dll | d2d1.h | [Vanara.PInvoke.D2d1.D2D1MakeRotateMatrix](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1MakeRotateMatrix)  
[D2D1MakeSkewMatrix](https://www.google.com/search?num=5&q=D2D1MakeSkewMatrix+site%3Alearn.microsoft.com) | d2d1.dll | d2d1.h | [Vanara.PInvoke.D2d1.D2D1MakeSkewMatrix](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1MakeSkewMatrix)  
[D2D1SinCos](https://www.google.com/search?num=5&q=D2D1SinCos+site%3Alearn.microsoft.com) | d2d1.dll | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1SinCos](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1SinCos)  
[D2D1Tan](https://www.google.com/search?num=5&q=D2D1Tan+site%3Alearn.microsoft.com) | d2d1.dll | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1Tan](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1Tan)  
[D2D1Vec3Length](https://www.google.com/search?num=5&q=D2D1Vec3Length+site%3Alearn.microsoft.com) | d2d1.dll | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1Vec3Length](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1Vec3Length)  
[DWriteCreateFactory](https://www.google.com/search?num=5&q=DWriteCreateFactory+site%3Alearn.microsoft.com) | dwrite.dll | dwrite.h | [Vanara.PInvoke.Dwrite.DWriteCreateFactory](https://github.com/dahall/Vanara/search?l=C%23&q=DWriteCreateFactory)  
[DXGIDeclareAdapterRemovalSupport](https://www.google.com/search?num=5&q=DXGIDeclareAdapterRemovalSupport+site%3Alearn.microsoft.com) | dxgi.dll | dxgi1_6.h | [Vanara.PInvoke.DXGI.DXGIDeclareAdapterRemovalSupport](https://github.com/dahall/Vanara/search?l=C%23&q=DXGIDeclareAdapterRemovalSupport)  
[DXGIGetDebugInterface1](https://www.google.com/search?num=5&q=DXGIGetDebugInterface1+site%3Alearn.microsoft.com) | dxgi.dll | dxgi1_3.h | [Vanara.PInvoke.DXGI.DXGIGetDebugInterface1](https://github.com/dahall/Vanara/search?l=C%23&q=DXGIGetDebugInterface1)  
[WICConvertBitmapSource](https://www.google.com/search?num=5&q=WICConvertBitmapSource+site%3Alearn.microsoft.com) | windowscodecs.dll | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICConvertBitmapSource](https://github.com/dahall/Vanara/search?l=C%23&q=WICConvertBitmapSource)  
[WICCreateBitmapFromSection](https://www.google.com/search?num=5&q=WICCreateBitmapFromSection+site%3Alearn.microsoft.com) | windowscodecs.dll | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICCreateBitmapFromSection](https://github.com/dahall/Vanara/search?l=C%23&q=WICCreateBitmapFromSection)  
[WICCreateBitmapFromSectionEx](https://www.google.com/search?num=5&q=WICCreateBitmapFromSectionEx+site%3Alearn.microsoft.com) | windowscodecs.dll | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICCreateBitmapFromSectionEx](https://github.com/dahall/Vanara/search?l=C%23&q=WICCreateBitmapFromSectionEx)  
[WICMapGuidToShortName](https://www.google.com/search?num=5&q=WICMapGuidToShortName+site%3Alearn.microsoft.com) | windowscodecs.dll | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICMapGuidToShortName](https://github.com/dahall/Vanara/search?l=C%23&q=WICMapGuidToShortName)  
[WICMapSchemaToName](https://www.google.com/search?num=5&q=WICMapSchemaToName+site%3Alearn.microsoft.com) | windowscodecs.dll | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICMapSchemaToName](https://github.com/dahall/Vanara/search?l=C%23&q=WICMapSchemaToName)  
[WICMapShortNameToGuid](https://www.google.com/search?num=5&q=WICMapShortNameToGuid+site%3Alearn.microsoft.com) | windowscodecs.dll | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICMapShortNameToGuid](https://github.com/dahall/Vanara/search?l=C%23&q=WICMapShortNameToGuid)  
### Enumerations  
Native Enum | Header | Managed Enum  
--- | --- | ---  
[D2D1_ALPHA_MODE](https://www.google.com/search?num=5&q=D2D1_ALPHA_MODE+site%3Alearn.microsoft.com) | dcommon.h | [Vanara.PInvoke.D2d1.D2D1_ALPHA_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_ALPHA_MODE)  
[D2D1_ANTIALIAS_MODE](https://www.google.com/search?num=5&q=D2D1_ANTIALIAS_MODE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_ANTIALIAS_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_ANTIALIAS_MODE)  
[D2D1_ARC_SIZE](https://www.google.com/search?num=5&q=D2D1_ARC_SIZE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_ARC_SIZE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_ARC_SIZE)  
[D2D1_BITMAP_INTERPOLATION_MODE](https://www.google.com/search?num=5&q=D2D1_BITMAP_INTERPOLATION_MODE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_BITMAP_INTERPOLATION_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_BITMAP_INTERPOLATION_MODE)  
[D2D1_BITMAP_OPTIONS](https://www.google.com/search?num=5&q=D2D1_BITMAP_OPTIONS+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_BITMAP_OPTIONS](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_BITMAP_OPTIONS)  
[D2D1_BUFFER_PRECISION](https://www.google.com/search?num=5&q=D2D1_BUFFER_PRECISION+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_BUFFER_PRECISION](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_BUFFER_PRECISION)  
[D2D1_CAP_STYLE](https://www.google.com/search?num=5&q=D2D1_CAP_STYLE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_CAP_STYLE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_CAP_STYLE)  
[D2D1_COLOR_INTERPOLATION_MODE](https://www.google.com/search?num=5&q=D2D1_COLOR_INTERPOLATION_MODE+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_COLOR_INTERPOLATION_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_COLOR_INTERPOLATION_MODE)  
[D2D1_COLOR_SPACE](https://www.google.com/search?num=5&q=D2D1_COLOR_SPACE+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_COLOR_SPACE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_COLOR_SPACE)  
[D2D1_COMBINE_MODE](https://www.google.com/search?num=5&q=D2D1_COMBINE_MODE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_COMBINE_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_COMBINE_MODE)  
[D2D1_COMPATIBLE_RENDER_TARGET_OPTIONS](https://www.google.com/search?num=5&q=D2D1_COMPATIBLE_RENDER_TARGET_OPTIONS+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_COMPATIBLE_RENDER_TARGET_OPTIONS](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_COMPATIBLE_RENDER_TARGET_OPTIONS)  
[D2D1_COMPOSITE_MODE](https://www.google.com/search?num=5&q=D2D1_COMPOSITE_MODE+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_COMPOSITE_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_COMPOSITE_MODE)  
[D2D1_DASH_STYLE](https://www.google.com/search?num=5&q=D2D1_DASH_STYLE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_DASH_STYLE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_DASH_STYLE)  
[D2D1_DC_INITIALIZE_MODE](https://www.google.com/search?num=5&q=D2D1_DC_INITIALIZE_MODE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_DC_INITIALIZE_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_DC_INITIALIZE_MODE)  
[D2D1_DEBUG_LEVEL](https://www.google.com/search?num=5&q=D2D1_DEBUG_LEVEL+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_DEBUG_LEVEL](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_DEBUG_LEVEL)  
[D2D1_DEVICE_CONTEXT_OPTIONS](https://www.google.com/search?num=5&q=D2D1_DEVICE_CONTEXT_OPTIONS+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_DEVICE_CONTEXT_OPTIONS](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_DEVICE_CONTEXT_OPTIONS)  
[D2D1_DRAW_TEXT_OPTIONS](https://www.google.com/search?num=5&q=D2D1_DRAW_TEXT_OPTIONS+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_DRAW_TEXT_OPTIONS](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_DRAW_TEXT_OPTIONS)  
[D2D1_EXTEND_MODE](https://www.google.com/search?num=5&q=D2D1_EXTEND_MODE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_EXTEND_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_EXTEND_MODE)  
[D2D1_FACTORY_TYPE](https://www.google.com/search?num=5&q=D2D1_FACTORY_TYPE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_FACTORY_TYPE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_FACTORY_TYPE)  
[D2D1_FEATURE_LEVEL](https://www.google.com/search?num=5&q=D2D1_FEATURE_LEVEL+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_FEATURE_LEVEL](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_FEATURE_LEVEL)  
[D2D1_FIGURE_BEGIN](https://www.google.com/search?num=5&q=D2D1_FIGURE_BEGIN+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_FIGURE_BEGIN](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_FIGURE_BEGIN)  
[D2D1_FIGURE_END](https://www.google.com/search?num=5&q=D2D1_FIGURE_END+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_FIGURE_END](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_FIGURE_END)  
[D2D1_FILL_MODE](https://www.google.com/search?num=5&q=D2D1_FILL_MODE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_FILL_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_FILL_MODE)  
[D2D1_GAMMA](https://www.google.com/search?num=5&q=D2D1_GAMMA+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_GAMMA](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_GAMMA)  
[D2D1_GEOMETRY_RELATION](https://www.google.com/search?num=5&q=D2D1_GEOMETRY_RELATION+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_GEOMETRY_RELATION](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_GEOMETRY_RELATION)  
[D2D1_GEOMETRY_SIMPLIFICATION_OPTION](https://www.google.com/search?num=5&q=D2D1_GEOMETRY_SIMPLIFICATION_OPTION+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_GEOMETRY_SIMPLIFICATION_OPTION](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_GEOMETRY_SIMPLIFICATION_OPTION)  
[D2D1_INTERPOLATION_MODE](https://www.google.com/search?num=5&q=D2D1_INTERPOLATION_MODE+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_INTERPOLATION_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_INTERPOLATION_MODE)  
[D2D1_LAYER_OPTIONS](https://www.google.com/search?num=5&q=D2D1_LAYER_OPTIONS+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_LAYER_OPTIONS](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_LAYER_OPTIONS)  
[D2D1_LAYER_OPTIONS1](https://www.google.com/search?num=5&q=D2D1_LAYER_OPTIONS1+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_LAYER_OPTIONS1](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_LAYER_OPTIONS1)  
[D2D1_LINE_JOIN](https://www.google.com/search?num=5&q=D2D1_LINE_JOIN+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_LINE_JOIN](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_LINE_JOIN)  
[D2D1_MAP_OPTIONS](https://www.google.com/search?num=5&q=D2D1_MAP_OPTIONS+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_MAP_OPTIONS](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_MAP_OPTIONS)  
[D2D1_OPACITY_MASK_CONTENT](https://www.google.com/search?num=5&q=D2D1_OPACITY_MASK_CONTENT+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_OPACITY_MASK_CONTENT](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_OPACITY_MASK_CONTENT)  
[D2D1_PATH_SEGMENT](https://www.google.com/search?num=5&q=D2D1_PATH_SEGMENT+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_PATH_SEGMENT](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_PATH_SEGMENT)  
[D2D1_PRESENT_OPTIONS](https://www.google.com/search?num=5&q=D2D1_PRESENT_OPTIONS+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_PRESENT_OPTIONS](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_PRESENT_OPTIONS)  
[D2D1_PRIMITIVE_BLEND](https://www.google.com/search?num=5&q=D2D1_PRIMITIVE_BLEND+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_PRIMITIVE_BLEND](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_PRIMITIVE_BLEND)  
[D2D1_PRINT_FONT_SUBSET_MODE](https://www.google.com/search?num=5&q=D2D1_PRINT_FONT_SUBSET_MODE+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_PRINT_FONT_SUBSET_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_PRINT_FONT_SUBSET_MODE)  
[D2D1_PROPERTY_TYPE](https://www.google.com/search?num=5&q=D2D1_PROPERTY_TYPE+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_PROPERTY_TYPE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_PROPERTY_TYPE)  
[D2D1_RENDER_TARGET_TYPE](https://www.google.com/search?num=5&q=D2D1_RENDER_TARGET_TYPE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_RENDER_TARGET_TYPE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_RENDER_TARGET_TYPE)  
[D2D1_RENDER_TARGET_USAGE](https://www.google.com/search?num=5&q=D2D1_RENDER_TARGET_USAGE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_RENDER_TARGET_USAGE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_RENDER_TARGET_USAGE)  
[D2D1_SWEEP_DIRECTION](https://www.google.com/search?num=5&q=D2D1_SWEEP_DIRECTION+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_SWEEP_DIRECTION](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_SWEEP_DIRECTION)  
[D2D1_TEXT_ANTIALIAS_MODE](https://www.google.com/search?num=5&q=D2D1_TEXT_ANTIALIAS_MODE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_TEXT_ANTIALIAS_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_TEXT_ANTIALIAS_MODE)  
[D2D1_THREADING_MODE](https://www.google.com/search?num=5&q=D2D1_THREADING_MODE+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_THREADING_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_THREADING_MODE)  
[D2D1_UNIT_MODE](https://www.google.com/search?num=5&q=D2D1_UNIT_MODE+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_UNIT_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_UNIT_MODE)  
[D2D1_WINDOW_STATE](https://www.google.com/search?num=5&q=D2D1_WINDOW_STATE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_WINDOW_STATE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_WINDOW_STATE)  
[DWRITE_BREAK_CONDITION](https://www.google.com/search?num=5&q=DWRITE_BREAK_CONDITION+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_BREAK_CONDITION](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_BREAK_CONDITION)  
[DWRITE_FACTORY_TYPE](https://www.google.com/search?num=5&q=DWRITE_FACTORY_TYPE+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FACTORY_TYPE](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FACTORY_TYPE)  
[DWRITE_FLOW_DIRECTION](https://www.google.com/search?num=5&q=DWRITE_FLOW_DIRECTION+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FLOW_DIRECTION](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FLOW_DIRECTION)  
[DWRITE_FONT_FACE_TYPE](https://www.google.com/search?num=5&q=DWRITE_FONT_FACE_TYPE+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FONT_FACE_TYPE](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FONT_FACE_TYPE)  
[DWRITE_FONT_FEATURE_TAG](https://www.google.com/search?num=5&q=DWRITE_FONT_FEATURE_TAG+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FONT_FEATURE_TAG](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FONT_FEATURE_TAG)  
[DWRITE_FONT_FILE_TYPE](https://www.google.com/search?num=5&q=DWRITE_FONT_FILE_TYPE+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FONT_FILE_TYPE](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FONT_FILE_TYPE)  
[DWRITE_FONT_SIMULATIONS](https://www.google.com/search?num=5&q=DWRITE_FONT_SIMULATIONS+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FONT_SIMULATIONS](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FONT_SIMULATIONS)  
[DWRITE_FONT_STRETCH](https://www.google.com/search?num=5&q=DWRITE_FONT_STRETCH+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FONT_STRETCH](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FONT_STRETCH)  
[DWRITE_FONT_STYLE](https://www.google.com/search?num=5&q=DWRITE_FONT_STYLE+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FONT_STYLE](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FONT_STYLE)  
[DWRITE_FONT_WEIGHT](https://www.google.com/search?num=5&q=DWRITE_FONT_WEIGHT+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FONT_WEIGHT](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FONT_WEIGHT)  
[DWRITE_INFORMATIONAL_STRING_ID](https://www.google.com/search?num=5&q=DWRITE_INFORMATIONAL_STRING_ID+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_INFORMATIONAL_STRING_ID](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_INFORMATIONAL_STRING_ID)  
[DWRITE_LINE_SPACING_METHOD](https://www.google.com/search?num=5&q=DWRITE_LINE_SPACING_METHOD+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_LINE_SPACING_METHOD](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_LINE_SPACING_METHOD)  
[DWRITE_MEASURING_MODE](https://www.google.com/search?num=5&q=DWRITE_MEASURING_MODE+site%3Alearn.microsoft.com) | dcommon.h | [Vanara.PInvoke.Dwrite.DWRITE_MEASURING_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_MEASURING_MODE)  
[DWRITE_NUMBER_SUBSTITUTION_METHOD](https://www.google.com/search?num=5&q=DWRITE_NUMBER_SUBSTITUTION_METHOD+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_NUMBER_SUBSTITUTION_METHOD](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_NUMBER_SUBSTITUTION_METHOD)  
[DWRITE_PARAGRAPH_ALIGNMENT](https://www.google.com/search?num=5&q=DWRITE_PARAGRAPH_ALIGNMENT+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_PARAGRAPH_ALIGNMENT](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_PARAGRAPH_ALIGNMENT)  
[DWRITE_PIXEL_GEOMETRY](https://www.google.com/search?num=5&q=DWRITE_PIXEL_GEOMETRY+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_PIXEL_GEOMETRY](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_PIXEL_GEOMETRY)  
[DWRITE_READING_DIRECTION](https://www.google.com/search?num=5&q=DWRITE_READING_DIRECTION+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_READING_DIRECTION](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_READING_DIRECTION)  
[DWRITE_RENDERING_MODE](https://www.google.com/search?num=5&q=DWRITE_RENDERING_MODE+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_RENDERING_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_RENDERING_MODE)  
[DWRITE_SCRIPT_SHAPES](https://www.google.com/search?num=5&q=DWRITE_SCRIPT_SHAPES+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_SCRIPT_SHAPES](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_SCRIPT_SHAPES)  
[DWRITE_TEXT_ALIGNMENT](https://www.google.com/search?num=5&q=DWRITE_TEXT_ALIGNMENT+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_TEXT_ALIGNMENT](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_TEXT_ALIGNMENT)  
[DWRITE_TEXTURE_TYPE](https://www.google.com/search?num=5&q=DWRITE_TEXTURE_TYPE+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_TEXTURE_TYPE](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_TEXTURE_TYPE)  
[DWRITE_TRIMMING_GRANULARITY](https://www.google.com/search?num=5&q=DWRITE_TRIMMING_GRANULARITY+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_TRIMMING_GRANULARITY](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_TRIMMING_GRANULARITY)  
[DWRITE_WORD_WRAPPING](https://www.google.com/search?num=5&q=DWRITE_WORD_WRAPPING+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_WORD_WRAPPING](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_WORD_WRAPPING)  
[DXGI_ADAPTER_FLAG](https://www.google.com/search?num=5&q=DXGI_ADAPTER_FLAG+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_ADAPTER_FLAG](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_ADAPTER_FLAG)  
[DXGI_CREATE_FACTORY](https://www.google.com/search?num=5&q=DXGI_CREATE_FACTORY+site%3Alearn.microsoft.com) | dxgi1_3.h | [Vanara.PInvoke.DXGI.DXGI_CREATE_FACTORY](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_CREATE_FACTORY)  
[DXGI_ENUM_MODES](https://www.google.com/search?num=5&q=DXGI_ENUM_MODES+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_ENUM_MODES](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_ENUM_MODES)  
[DXGI_FORMAT](https://www.google.com/search?num=5&q=DXGI_FORMAT+site%3Alearn.microsoft.com) | dxgiformat.h | [Vanara.PInvoke.DXGI.DXGI_FORMAT](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_FORMAT)  
[DXGI_MAP](https://www.google.com/search?num=5&q=DXGI_MAP+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_MAP](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_MAP)  
[DXGI_MODE_ROTATION](https://www.google.com/search?num=5&q=DXGI_MODE_ROTATION+site%3Alearn.microsoft.com) | DXGI.h | [Vanara.PInvoke.DXGI.DXGI_MODE_ROTATION](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_MODE_ROTATION)  
[DXGI_MODE_SCALING](https://www.google.com/search?num=5&q=DXGI_MODE_SCALING+site%3Alearn.microsoft.com) | DXGI.h | [Vanara.PInvoke.DXGI.DXGI_MODE_SCALING](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_MODE_SCALING)  
[DXGI_MODE_SCANLINE_ORDER](https://www.google.com/search?num=5&q=DXGI_MODE_SCANLINE_ORDER+site%3Alearn.microsoft.com) | DXGI.h | [Vanara.PInvoke.DXGI.DXGI_MODE_SCANLINE_ORDER](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_MODE_SCANLINE_ORDER)  
[DXGI_MWA](https://www.google.com/search?num=5&q=DXGI_MWA+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_MWA](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_MWA)  
[DXGI_PRESENT](https://www.google.com/search?num=5&q=DXGI_PRESENT+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_PRESENT](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_PRESENT)  
[DXGI_RESIDENCY](https://www.google.com/search?num=5&q=DXGI_RESIDENCY+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_RESIDENCY](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_RESIDENCY)  
[DXGI_SWAP_CHAIN_FLAG](https://www.google.com/search?num=5&q=DXGI_SWAP_CHAIN_FLAG+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_SWAP_CHAIN_FLAG](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_SWAP_CHAIN_FLAG)  
[DXGI_SWAP_EFFECT](https://www.google.com/search?num=5&q=DXGI_SWAP_EFFECT+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_SWAP_EFFECT](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_SWAP_EFFECT)  
[DXGI_USAGE](https://www.google.com/search?num=5&q=DXGI_USAGE+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.DXGI.DXGI_USAGE](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_USAGE)  
[WIC_JPEG_HUFFMAN_BASELINE](https://www.google.com/search?num=5&q=WIC_JPEG_HUFFMAN_BASELINE+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WIC_JPEG_HUFFMAN_BASELINE](https://github.com/dahall/Vanara/search?l=C%23&q=WIC_JPEG_HUFFMAN_BASELINE)  
[WIC_JPEG_QUANTIZATION_BASELINE](https://www.google.com/search?num=5&q=WIC_JPEG_QUANTIZATION_BASELINE+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WIC_JPEG_QUANTIZATION_BASELINE](https://github.com/dahall/Vanara/search?l=C%23&q=WIC_JPEG_QUANTIZATION_BASELINE)  
[WIC_JPEG_SAMPLE_FACTORS](https://www.google.com/search?num=5&q=WIC_JPEG_SAMPLE_FACTORS+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WIC_JPEG_SAMPLE_FACTORS](https://github.com/dahall/Vanara/search?l=C%23&q=WIC_JPEG_SAMPLE_FACTORS)  
[WIC8BIMIptcDigestProperties](https://www.google.com/search?num=5&q=WIC8BIMIptcDigestProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WIC8BIMIptcDigestProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WIC8BIMIptcDigestProperties)  
[WIC8BIMIptcProperties](https://www.google.com/search?num=5&q=WIC8BIMIptcProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WIC8BIMIptcProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WIC8BIMIptcProperties)  
[WIC8BIMResolutionInfoProperties](https://www.google.com/search?num=5&q=WIC8BIMResolutionInfoProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WIC8BIMResolutionInfoProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WIC8BIMResolutionInfoProperties)  
[WICBitmapAlphaChannelOption](https://www.google.com/search?num=5&q=WICBitmapAlphaChannelOption+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapAlphaChannelOption](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapAlphaChannelOption)  
[WICBitmapCreateCacheOption](https://www.google.com/search?num=5&q=WICBitmapCreateCacheOption+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapCreateCacheOption](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapCreateCacheOption)  
[WICBitmapDecoderCapabilities](https://www.google.com/search?num=5&q=WICBitmapDecoderCapabilities+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapDecoderCapabilities](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapDecoderCapabilities)  
[WICBitmapDitherType](https://www.google.com/search?num=5&q=WICBitmapDitherType+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapDitherType](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapDitherType)  
[WICBitmapEncoderCacheOption](https://www.google.com/search?num=5&q=WICBitmapEncoderCacheOption+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapEncoderCacheOption](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapEncoderCacheOption)  
[WICBitmapInterpolationMode](https://www.google.com/search?num=5&q=WICBitmapInterpolationMode+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapInterpolationMode](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapInterpolationMode)  
[WICBitmapLockFlags](https://www.google.com/search?num=5&q=WICBitmapLockFlags+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapLockFlags](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapLockFlags)  
[WICBitmapPaletteType](https://www.google.com/search?num=5&q=WICBitmapPaletteType+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapPaletteType](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapPaletteType)  
[WICBitmapTransformOptions](https://www.google.com/search?num=5&q=WICBitmapTransformOptions+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapTransformOptions](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapTransformOptions)  
[WICColorContextType](https://www.google.com/search?num=5&q=WICColorContextType+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICColorContextType](https://github.com/dahall/Vanara/search?l=C%23&q=WICColorContextType)  
[WICComponentEnumerateOptions](https://www.google.com/search?num=5&q=WICComponentEnumerateOptions+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICComponentEnumerateOptions](https://github.com/dahall/Vanara/search?l=C%23&q=WICComponentEnumerateOptions)  
[WICComponentSigning](https://www.google.com/search?num=5&q=WICComponentSigning+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICComponentSigning](https://github.com/dahall/Vanara/search?l=C%23&q=WICComponentSigning)  
[WICComponentType](https://www.google.com/search?num=5&q=WICComponentType+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICComponentType](https://github.com/dahall/Vanara/search?l=C%23&q=WICComponentType)  
[WICDdsAlphaMode](https://www.google.com/search?num=5&q=WICDdsAlphaMode+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICDdsAlphaMode](https://github.com/dahall/Vanara/search?l=C%23&q=WICDdsAlphaMode)  
[WICDdsDimension](https://www.google.com/search?num=5&q=WICDdsDimension+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICDdsDimension](https://github.com/dahall/Vanara/search?l=C%23&q=WICDdsDimension)  
[WICDecodeOptions](https://www.google.com/search?num=5&q=WICDecodeOptions+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICDecodeOptions](https://github.com/dahall/Vanara/search?l=C%23&q=WICDecodeOptions)  
[WICGifApplicationExtensionProperties](https://www.google.com/search?num=5&q=WICGifApplicationExtensionProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICGifApplicationExtensionProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICGifApplicationExtensionProperties)  
[WICGifCommentExtensionProperties](https://www.google.com/search?num=5&q=WICGifCommentExtensionProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICGifCommentExtensionProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICGifCommentExtensionProperties)  
[WICGifGraphicControlExtensionProperties](https://www.google.com/search?num=5&q=WICGifGraphicControlExtensionProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICGifGraphicControlExtensionProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICGifGraphicControlExtensionProperties)  
[WICGifImageDescriptorProperties](https://www.google.com/search?num=5&q=WICGifImageDescriptorProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICGifImageDescriptorProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICGifImageDescriptorProperties)  
[WICGifLogicalScreenDescriptorProperties](https://www.google.com/search?num=5&q=WICGifLogicalScreenDescriptorProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICGifLogicalScreenDescriptorProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICGifLogicalScreenDescriptorProperties)  
[WICHeifHdrProperties](https://www.google.com/search?num=5&q=WICHeifHdrProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICHeifHdrProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICHeifHdrProperties)  
[WICJpegChrominanceProperties](https://www.google.com/search?num=5&q=WICJpegChrominanceProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICJpegChrominanceProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICJpegChrominanceProperties)  
[WICJpegCommentProperties](https://www.google.com/search?num=5&q=WICJpegCommentProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICJpegCommentProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICJpegCommentProperties)  
[WICJpegFrameDecode](https://www.google.com/search?num=5&q=WICJpegFrameDecode+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICJpegFrameDecode](https://github.com/dahall/Vanara/search?l=C%23&q=WICJpegFrameDecode)  
[WICJpegIndexingOptions](https://www.google.com/search?num=5&q=WICJpegIndexingOptions+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICJpegIndexingOptions](https://github.com/dahall/Vanara/search?l=C%23&q=WICJpegIndexingOptions)  
[WICJpegLuminanceProperties](https://www.google.com/search?num=5&q=WICJpegLuminanceProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICJpegLuminanceProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICJpegLuminanceProperties)  
[WICJpegScanType](https://www.google.com/search?num=5&q=WICJpegScanType+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICJpegScanType](https://github.com/dahall/Vanara/search?l=C%23&q=WICJpegScanType)  
[WICJpegTransferMatrix](https://www.google.com/search?num=5&q=WICJpegTransferMatrix+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICJpegTransferMatrix](https://github.com/dahall/Vanara/search?l=C%23&q=WICJpegTransferMatrix)  
[WICJpegYCrCbSubsamplingOption](https://www.google.com/search?num=5&q=WICJpegYCrCbSubsamplingOption+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICJpegYCrCbSubsamplingOption](https://github.com/dahall/Vanara/search?l=C%23&q=WICJpegYCrCbSubsamplingOption)  
[WICMetadataCreationOptions](https://www.google.com/search?num=5&q=WICMetadataCreationOptions+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.WICMetadataCreationOptions](https://github.com/dahall/Vanara/search?l=C%23&q=WICMetadataCreationOptions)  
[WICNamedWhitePoint](https://www.google.com/search?num=5&q=WICNamedWhitePoint+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICNamedWhitePoint](https://github.com/dahall/Vanara/search?l=C%23&q=WICNamedWhitePoint)  
[WICPersistOptions](https://www.google.com/search?num=5&q=WICPersistOptions+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.WICPersistOptions](https://github.com/dahall/Vanara/search?l=C%23&q=WICPersistOptions)  
[WICPixelFormatNumericRepresentation](https://www.google.com/search?num=5&q=WICPixelFormatNumericRepresentation+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPixelFormatNumericRepresentation](https://github.com/dahall/Vanara/search?l=C%23&q=WICPixelFormatNumericRepresentation)  
[WICPlanarOptions](https://www.google.com/search?num=5&q=WICPlanarOptions+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPlanarOptions](https://github.com/dahall/Vanara/search?l=C%23&q=WICPlanarOptions)  
[WICPngBkgdProperties](https://www.google.com/search?num=5&q=WICPngBkgdProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPngBkgdProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICPngBkgdProperties)  
[WICPngChrmProperties](https://www.google.com/search?num=5&q=WICPngChrmProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPngChrmProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICPngChrmProperties)  
[WICPngFilterOption](https://www.google.com/search?num=5&q=WICPngFilterOption+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPngFilterOption](https://github.com/dahall/Vanara/search?l=C%23&q=WICPngFilterOption)  
[WICPngGamaProperties](https://www.google.com/search?num=5&q=WICPngGamaProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPngGamaProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICPngGamaProperties)  
[WICPngHistProperties](https://www.google.com/search?num=5&q=WICPngHistProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPngHistProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICPngHistProperties)  
[WICPngIccpProperties](https://www.google.com/search?num=5&q=WICPngIccpProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPngIccpProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICPngIccpProperties)  
[WICPngItxtProperties](https://www.google.com/search?num=5&q=WICPngItxtProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPngItxtProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICPngItxtProperties)  
[WICPngSrgbProperties](https://www.google.com/search?num=5&q=WICPngSrgbProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPngSrgbProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICPngSrgbProperties)  
[WICPngTimeProperties](https://www.google.com/search?num=5&q=WICPngTimeProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICPngTimeProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICPngTimeProperties)  
[WICProgressNotification](https://www.google.com/search?num=5&q=WICProgressNotification+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICProgressNotification](https://github.com/dahall/Vanara/search?l=C%23&q=WICProgressNotification)  
[WICProgressOperation](https://www.google.com/search?num=5&q=WICProgressOperation+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICProgressOperation](https://github.com/dahall/Vanara/search?l=C%23&q=WICProgressOperation)  
[WICRawCapabilities](https://www.google.com/search?num=5&q=WICRawCapabilities+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICRawCapabilities](https://github.com/dahall/Vanara/search?l=C%23&q=WICRawCapabilities)  
[WICRawChangeNotification](https://www.google.com/search?num=5&q=WICRawChangeNotification+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICRawChangeNotification](https://github.com/dahall/Vanara/search?l=C%23&q=WICRawChangeNotification)  
[WICRawParameterSet](https://www.google.com/search?num=5&q=WICRawParameterSet+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICRawParameterSet](https://github.com/dahall/Vanara/search?l=C%23&q=WICRawParameterSet)  
[WICRawRenderMode](https://www.google.com/search?num=5&q=WICRawRenderMode+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICRawRenderMode](https://github.com/dahall/Vanara/search?l=C%23&q=WICRawRenderMode)  
[WICRawRotationCapabilities](https://www.google.com/search?num=5&q=WICRawRotationCapabilities+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICRawRotationCapabilities](https://github.com/dahall/Vanara/search?l=C%23&q=WICRawRotationCapabilities)  
[WICSectionAccessLevel](https://www.google.com/search?num=5&q=WICSectionAccessLevel+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICSectionAccessLevel](https://github.com/dahall/Vanara/search?l=C%23&q=WICSectionAccessLevel)  
[WICTiffCompressionOption](https://www.google.com/search?num=5&q=WICTiffCompressionOption+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICTiffCompressionOption](https://github.com/dahall/Vanara/search?l=C%23&q=WICTiffCompressionOption)  
[WICWebpAnimProperties](https://www.google.com/search?num=5&q=WICWebpAnimProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICWebpAnimProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICWebpAnimProperties)  
[WICWebpAnmfProperties](https://www.google.com/search?num=5&q=WICWebpAnmfProperties+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICWebpAnmfProperties](https://github.com/dahall/Vanara/search?l=C%23&q=WICWebpAnmfProperties)  
### Structures  
Native Structure | Header | Managed Structure  
--- | --- | ---  
[D2D_MATRIX_3X2_F](https://www.google.com/search?num=5&q=D2D_MATRIX_3X2_F+site%3Alearn.microsoft.com) | dcommon.h | [Vanara.PInvoke.D2d1.D2D_MATRIX_3X2_F](https://github.com/dahall/Vanara/search?l=C%23&q=D2D_MATRIX_3X2_F)  
[D2D_POINT_2F](https://www.google.com/search?num=5&q=D2D_POINT_2F+site%3Alearn.microsoft.com) | dcommon.h | [Vanara.PInvoke.D2d1.D2D_POINT_2F](https://github.com/dahall/Vanara/search?l=C%23&q=D2D_POINT_2F)  
[D2D_RECT_F](https://www.google.com/search?num=5&q=D2D_RECT_F+site%3Alearn.microsoft.com) | dcommon.h | [Vanara.PInvoke.D2d1.D2D_RECT_F](https://github.com/dahall/Vanara/search?l=C%23&q=D2D_RECT_F)  
[D2D_SIZE_F](https://www.google.com/search?num=5&q=D2D_SIZE_F+site%3Alearn.microsoft.com) | dcommon.h | [Vanara.PInvoke.D2d1.D2D_SIZE_F](https://github.com/dahall/Vanara/search?l=C%23&q=D2D_SIZE_F)  
[D2D_SIZE_U](https://www.google.com/search?num=5&q=D2D_SIZE_U+site%3Alearn.microsoft.com) | dcommon.h | [Vanara.PInvoke.D2d1.D2D_SIZE_U](https://github.com/dahall/Vanara/search?l=C%23&q=D2D_SIZE_U)  
[D2D1_ARC_SEGMENT](https://www.google.com/search?num=5&q=D2D1_ARC_SEGMENT+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_ARC_SEGMENT](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_ARC_SEGMENT)  
[D2D1_BEZIER_SEGMENT](https://www.google.com/search?num=5&q=D2D1_BEZIER_SEGMENT+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_BEZIER_SEGMENT](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_BEZIER_SEGMENT)  
[D2D1_BITMAP_BRUSH_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_BITMAP_BRUSH_PROPERTIES+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_BITMAP_BRUSH_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_BITMAP_BRUSH_PROPERTIES)  
[D2D1_BITMAP_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_BITMAP_PROPERTIES+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_BITMAP_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_BITMAP_PROPERTIES)  
[D2D1_BITMAP_PROPERTIES1](https://www.google.com/search?num=5&q=D2D1_BITMAP_PROPERTIES1+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_BITMAP_PROPERTIES1](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_BITMAP_PROPERTIES1)  
[D2D1_BRUSH_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_BRUSH_PROPERTIES+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_BRUSH_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_BRUSH_PROPERTIES)  
[D2D1_CREATION_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_CREATION_PROPERTIES+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_CREATION_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_CREATION_PROPERTIES)  
[D2D1_DRAWING_STATE_DESCRIPTION](https://www.google.com/search?num=5&q=D2D1_DRAWING_STATE_DESCRIPTION+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_DRAWING_STATE_DESCRIPTION](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_DRAWING_STATE_DESCRIPTION)  
[D2D1_EFFECT_INPUT_DESCRIPTION](https://www.google.com/search?num=5&q=D2D1_EFFECT_INPUT_DESCRIPTION+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_EFFECT_INPUT_DESCRIPTION](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_EFFECT_INPUT_DESCRIPTION)  
[D2D1_ELLIPSE](https://www.google.com/search?num=5&q=D2D1_ELLIPSE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_ELLIPSE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_ELLIPSE)  
[D2D1_FACTORY_OPTIONS](https://www.google.com/search?num=5&q=D2D1_FACTORY_OPTIONS+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_FACTORY_OPTIONS](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_FACTORY_OPTIONS)  
[D2D1_GRADIENT_STOP](https://www.google.com/search?num=5&q=D2D1_GRADIENT_STOP+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_GRADIENT_STOP](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_GRADIENT_STOP)  
[D2D1_HWND_RENDER_TARGET_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_HWND_RENDER_TARGET_PROPERTIES+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_HWND_RENDER_TARGET_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_HWND_RENDER_TARGET_PROPERTIES)  
[D2D1_IMAGE_BRUSH_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_IMAGE_BRUSH_PROPERTIES+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_IMAGE_BRUSH_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_IMAGE_BRUSH_PROPERTIES)  
[D2D1_LAYER_PARAMETERS](https://www.google.com/search?num=5&q=D2D1_LAYER_PARAMETERS+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_LAYER_PARAMETERS](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_LAYER_PARAMETERS)  
[D2D1_LAYER_PARAMETERS1](https://www.google.com/search?num=5&q=D2D1_LAYER_PARAMETERS1+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_LAYER_PARAMETERS1](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_LAYER_PARAMETERS1)  
[D2D1_LINEAR_GRADIENT_BRUSH_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_LINEAR_GRADIENT_BRUSH_PROPERTIES+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_LINEAR_GRADIENT_BRUSH_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_LINEAR_GRADIENT_BRUSH_PROPERTIES)  
[D2D1_MAPPED_RECT](https://www.google.com/search?num=5&q=D2D1_MAPPED_RECT+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_MAPPED_RECT](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_MAPPED_RECT)  
[D2D1_PIXEL_FORMAT](https://www.google.com/search?num=5&q=D2D1_PIXEL_FORMAT+site%3Alearn.microsoft.com) | dcommon.h | [Vanara.PInvoke.D2d1.D2D1_PIXEL_FORMAT](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_PIXEL_FORMAT)  
[D2D1_PRINT_CONTROL_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_PRINT_CONTROL_PROPERTIES+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_PRINT_CONTROL_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_PRINT_CONTROL_PROPERTIES)  
[D2D1_QUADRATIC_BEZIER_SEGMENT](https://www.google.com/search?num=5&q=D2D1_QUADRATIC_BEZIER_SEGMENT+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_QUADRATIC_BEZIER_SEGMENT](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_QUADRATIC_BEZIER_SEGMENT)  
[D2D1_RADIAL_GRADIENT_BRUSH_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_RADIAL_GRADIENT_BRUSH_PROPERTIES+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_RADIAL_GRADIENT_BRUSH_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_RADIAL_GRADIENT_BRUSH_PROPERTIES)  
[D2D1_RENDER_TARGET_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_RENDER_TARGET_PROPERTIES+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_RENDER_TARGET_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_RENDER_TARGET_PROPERTIES)  
[D2D1_RENDERING_CONTROLS](https://www.google.com/search?num=5&q=D2D1_RENDERING_CONTROLS+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.D2D1_RENDERING_CONTROLS](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_RENDERING_CONTROLS)  
[D2D1_ROUNDED_RECT](https://www.google.com/search?num=5&q=D2D1_ROUNDED_RECT+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_ROUNDED_RECT](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_ROUNDED_RECT)  
[D2D1_STROKE_STYLE_PROPERTIES](https://www.google.com/search?num=5&q=D2D1_STROKE_STYLE_PROPERTIES+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_STROKE_STYLE_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_STROKE_STYLE_PROPERTIES)  
[D2D1_TRIANGLE](https://www.google.com/search?num=5&q=D2D1_TRIANGLE+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.D2D1_TRIANGLE](https://github.com/dahall/Vanara/search?l=C%23&q=D2D1_TRIANGLE)  
[D3DCOLORVALUE](https://www.google.com/search?num=5&q=D3DCOLORVALUE+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.D2d1.D3DCOLORVALUE](https://github.com/dahall/Vanara/search?l=C%23&q=D3DCOLORVALUE)  
[DWRITE_CLUSTER_METRICS](https://www.google.com/search?num=5&q=DWRITE_CLUSTER_METRICS+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_CLUSTER_METRICS](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_CLUSTER_METRICS)  
[DWRITE_FONT_FEATURE](https://www.google.com/search?num=5&q=DWRITE_FONT_FEATURE+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FONT_FEATURE](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FONT_FEATURE)  
[DWRITE_FONT_METRICS](https://www.google.com/search?num=5&q=DWRITE_FONT_METRICS+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_FONT_METRICS](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_FONT_METRICS)  
[DWRITE_GLYPH_METRICS](https://www.google.com/search?num=5&q=DWRITE_GLYPH_METRICS+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_GLYPH_METRICS](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_GLYPH_METRICS)  
[DWRITE_GLYPH_OFFSET](https://www.google.com/search?num=5&q=DWRITE_GLYPH_OFFSET+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_GLYPH_OFFSET](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_GLYPH_OFFSET)  
[DWRITE_GLYPH_RUN](https://www.google.com/search?num=5&q=DWRITE_GLYPH_RUN+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.D2d1.DWRITE_GLYPH_RUN](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_GLYPH_RUN)  
[DWRITE_GLYPH_RUN](https://www.google.com/search?num=5&q=DWRITE_GLYPH_RUN+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_GLYPH_RUN](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_GLYPH_RUN)  
[DWRITE_GLYPH_RUN_DESCRIPTION](https://www.google.com/search?num=5&q=DWRITE_GLYPH_RUN_DESCRIPTION+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_GLYPH_RUN_DESCRIPTION](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_GLYPH_RUN_DESCRIPTION)  
[DWRITE_HIT_TEST_METRICS](https://www.google.com/search?num=5&q=DWRITE_HIT_TEST_METRICS+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_HIT_TEST_METRICS](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_HIT_TEST_METRICS)  
[DWRITE_INLINE_OBJECT_METRICS](https://www.google.com/search?num=5&q=DWRITE_INLINE_OBJECT_METRICS+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_INLINE_OBJECT_METRICS](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_INLINE_OBJECT_METRICS)  
[DWRITE_LINE_BREAKPOINT](https://www.google.com/search?num=5&q=DWRITE_LINE_BREAKPOINT+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_LINE_BREAKPOINT](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_LINE_BREAKPOINT)  
[DWRITE_LINE_METRICS](https://www.google.com/search?num=5&q=DWRITE_LINE_METRICS+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_LINE_METRICS](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_LINE_METRICS)  
[DWRITE_MATRIX](https://www.google.com/search?num=5&q=DWRITE_MATRIX+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_MATRIX](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_MATRIX)  
[DWRITE_OVERHANG_METRICS](https://www.google.com/search?num=5&q=DWRITE_OVERHANG_METRICS+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_OVERHANG_METRICS](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_OVERHANG_METRICS)  
[DWRITE_SCRIPT_ANALYSIS](https://www.google.com/search?num=5&q=DWRITE_SCRIPT_ANALYSIS+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_SCRIPT_ANALYSIS](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_SCRIPT_ANALYSIS)  
[DWRITE_SHAPING_GLYPH_PROPERTIES](https://www.google.com/search?num=5&q=DWRITE_SHAPING_GLYPH_PROPERTIES+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_SHAPING_GLYPH_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_SHAPING_GLYPH_PROPERTIES)  
[DWRITE_SHAPING_TEXT_PROPERTIES](https://www.google.com/search?num=5&q=DWRITE_SHAPING_TEXT_PROPERTIES+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_SHAPING_TEXT_PROPERTIES](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_SHAPING_TEXT_PROPERTIES)  
[DWRITE_STRIKETHROUGH](https://www.google.com/search?num=5&q=DWRITE_STRIKETHROUGH+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_STRIKETHROUGH](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_STRIKETHROUGH)  
[DWRITE_TEXT_METRICS](https://www.google.com/search?num=5&q=DWRITE_TEXT_METRICS+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_TEXT_METRICS](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_TEXT_METRICS)  
[DWRITE_TEXT_RANGE](https://www.google.com/search?num=5&q=DWRITE_TEXT_RANGE+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_TEXT_RANGE](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_TEXT_RANGE)  
[DWRITE_TRIMMING](https://www.google.com/search?num=5&q=DWRITE_TRIMMING+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_TRIMMING](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_TRIMMING)  
[DWRITE_TYPOGRAPHIC_FEATURES](https://www.google.com/search?num=5&q=DWRITE_TYPOGRAPHIC_FEATURES+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_TYPOGRAPHIC_FEATURES](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_TYPOGRAPHIC_FEATURES)  
[DWRITE_UNDERLINE](https://www.google.com/search?num=5&q=DWRITE_UNDERLINE+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.DWRITE_UNDERLINE](https://github.com/dahall/Vanara/search?l=C%23&q=DWRITE_UNDERLINE)  
[DXGI_ADAPTER_DESC](https://www.google.com/search?num=5&q=DXGI_ADAPTER_DESC+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_ADAPTER_DESC](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_ADAPTER_DESC)  
[DXGI_ADAPTER_DESC1](https://www.google.com/search?num=5&q=DXGI_ADAPTER_DESC1+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_ADAPTER_DESC1](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_ADAPTER_DESC1)  
[DXGI_FRAME_STATISTICS](https://www.google.com/search?num=5&q=DXGI_FRAME_STATISTICS+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_FRAME_STATISTICS](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_FRAME_STATISTICS)  
[DXGI_GAMMA_CONTROL](https://www.google.com/search?num=5&q=DXGI_GAMMA_CONTROL+site%3Alearn.microsoft.com) | DXGI.h | [Vanara.PInvoke.DXGI.DXGI_GAMMA_CONTROL](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_GAMMA_CONTROL)  
[DXGI_GAMMA_CONTROL_CAPABILITIES](https://www.google.com/search?num=5&q=DXGI_GAMMA_CONTROL_CAPABILITIES+site%3Alearn.microsoft.com) | dxgitype.h | [Vanara.PInvoke.DXGI.DXGI_GAMMA_CONTROL_CAPABILITIES](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_GAMMA_CONTROL_CAPABILITIES)  
[DXGI_JPEG_AC_HUFFMAN_TABLE](https://www.google.com/search?num=5&q=DXGI_JPEG_AC_HUFFMAN_TABLE+site%3Alearn.microsoft.com) | dxgitype.h | [Vanara.PInvoke.D2d1.DXGI_JPEG_AC_HUFFMAN_TABLE](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_JPEG_AC_HUFFMAN_TABLE)  
[DXGI_JPEG_DC_HUFFMAN_TABLE](https://www.google.com/search?num=5&q=DXGI_JPEG_DC_HUFFMAN_TABLE+site%3Alearn.microsoft.com) | dxgitype.h | [Vanara.PInvoke.D2d1.DXGI_JPEG_DC_HUFFMAN_TABLE](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_JPEG_DC_HUFFMAN_TABLE)  
[DXGI_JPEG_QUANTIZATION_TABLE](https://www.google.com/search?num=5&q=DXGI_JPEG_QUANTIZATION_TABLE+site%3Alearn.microsoft.com) | dxgitype.h | [Vanara.PInvoke.D2d1.DXGI_JPEG_QUANTIZATION_TABLE](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_JPEG_QUANTIZATION_TABLE)  
[DXGI_MAPPED_RECT](https://www.google.com/search?num=5&q=DXGI_MAPPED_RECT+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_MAPPED_RECT](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_MAPPED_RECT)  
[DXGI_MODE_DESC](https://www.google.com/search?num=5&q=DXGI_MODE_DESC+site%3Alearn.microsoft.com) | DXGI.h | [Vanara.PInvoke.DXGI.DXGI_MODE_DESC](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_MODE_DESC)  
[DXGI_OUTPUT_DESC](https://www.google.com/search?num=5&q=DXGI_OUTPUT_DESC+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_OUTPUT_DESC](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_OUTPUT_DESC)  
[DXGI_RATIONAL](https://www.google.com/search?num=5&q=DXGI_RATIONAL+site%3Alearn.microsoft.com) | dxgicommon.h | [Vanara.PInvoke.DXGI.DXGI_RATIONAL](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_RATIONAL)  
[DXGI_RGB](https://www.google.com/search?num=5&q=DXGI_RGB+site%3Alearn.microsoft.com) | DXGI.h | [Vanara.PInvoke.DXGI.DXGI_RGB](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_RGB)  
[DXGI_SAMPLE_DESC](https://www.google.com/search?num=5&q=DXGI_SAMPLE_DESC+site%3Alearn.microsoft.com) | dxgicommon.h | [Vanara.PInvoke.DXGI.DXGI_SAMPLE_DESC](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_SAMPLE_DESC)  
[DXGI_SHARED_RESOURCE](https://www.google.com/search?num=5&q=DXGI_SHARED_RESOURCE+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_SHARED_RESOURCE](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_SHARED_RESOURCE)  
[DXGI_SURFACE_DESC](https://www.google.com/search?num=5&q=DXGI_SURFACE_DESC+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_SURFACE_DESC](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_SURFACE_DESC)  
[DXGI_SWAP_CHAIN_DESC](https://www.google.com/search?num=5&q=DXGI_SWAP_CHAIN_DESC+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.DXGI_SWAP_CHAIN_DESC](https://github.com/dahall/Vanara/search?l=C%23&q=DXGI_SWAP_CHAIN_DESC)  
[PWICRect](https://www.google.com/search?num=5&q=PWICRect+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.PWICRect](https://github.com/dahall/Vanara/search?l=C%23&q=PWICRect)  
[WICBitmapPattern](https://www.google.com/search?num=5&q=WICBitmapPattern+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapPattern](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapPattern)  
[WICBitmapPlane](https://www.google.com/search?num=5&q=WICBitmapPlane+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapPlane](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapPlane)  
[WICBitmapPlaneDescription](https://www.google.com/search?num=5&q=WICBitmapPlaneDescription+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICBitmapPlaneDescription](https://github.com/dahall/Vanara/search?l=C%23&q=WICBitmapPlaneDescription)  
[WICDdsFormatInfo](https://www.google.com/search?num=5&q=WICDdsFormatInfo+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICDdsFormatInfo](https://github.com/dahall/Vanara/search?l=C%23&q=WICDdsFormatInfo)  
[WICDdsParameters](https://www.google.com/search?num=5&q=WICDdsParameters+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICDdsParameters](https://github.com/dahall/Vanara/search?l=C%23&q=WICDdsParameters)  
[WICImageParameters](https://www.google.com/search?num=5&q=WICImageParameters+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICImageParameters](https://github.com/dahall/Vanara/search?l=C%23&q=WICImageParameters)  
[WICJpegFrameHeader](https://www.google.com/search?num=5&q=WICJpegFrameHeader+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICJpegFrameHeader](https://github.com/dahall/Vanara/search?l=C%23&q=WICJpegFrameHeader)  
[WICJpegScanHeader](https://www.google.com/search?num=5&q=WICJpegScanHeader+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICJpegScanHeader](https://github.com/dahall/Vanara/search?l=C%23&q=WICJpegScanHeader)  
[WICMetadataHeader](https://www.google.com/search?num=5&q=WICMetadataHeader+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.WICMetadataHeader](https://github.com/dahall/Vanara/search?l=C%23&q=WICMetadataHeader)  
[WICMetadataPattern](https://www.google.com/search?num=5&q=WICMetadataPattern+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.WICMetadataPattern](https://github.com/dahall/Vanara/search?l=C%23&q=WICMetadataPattern)  
[WICRawCapabilitiesInfo](https://www.google.com/search?num=5&q=WICRawCapabilitiesInfo+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICRawCapabilitiesInfo](https://github.com/dahall/Vanara/search?l=C%23&q=WICRawCapabilitiesInfo)  
[WICRawToneCurve](https://www.google.com/search?num=5&q=WICRawToneCurve+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICRawToneCurve](https://github.com/dahall/Vanara/search?l=C%23&q=WICRawToneCurve)  
[WICRawToneCurvePoint](https://www.google.com/search?num=5&q=WICRawToneCurvePoint+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICRawToneCurvePoint](https://github.com/dahall/Vanara/search?l=C%23&q=WICRawToneCurvePoint)  
[WICRect](https://www.google.com/search?num=5&q=WICRect+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICRect](https://github.com/dahall/Vanara/search?l=C%23&q=WICRect)  
### Interfaces  
Native Interface | Header | Managed Interface  
--- | --- | ---  
[ID2D1Bitmap](https://www.google.com/search?num=5&q=ID2D1Bitmap+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1Bitmap](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Bitmap)  
[ID2D1Bitmap1](https://www.google.com/search?num=5&q=ID2D1Bitmap1+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1Bitmap1](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Bitmap1)  
[ID2D1BitmapBrush](https://www.google.com/search?num=5&q=ID2D1BitmapBrush+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1BitmapBrush](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1BitmapBrush)  
[ID2D1BitmapBrush1](https://www.google.com/search?num=5&q=ID2D1BitmapBrush1+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1BitmapBrush1](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1BitmapBrush1)  
[ID2D1BitmapRenderTarget](https://www.google.com/search?num=5&q=ID2D1BitmapRenderTarget+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1BitmapRenderTarget](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1BitmapRenderTarget)  
[ID2D1Brush](https://www.google.com/search?num=5&q=ID2D1Brush+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1Brush](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Brush)  
[ID2D1ColorContext](https://www.google.com/search?num=5&q=ID2D1ColorContext+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1ColorContext](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1ColorContext)  
[ID2D1CommandList](https://www.google.com/search?num=5&q=ID2D1CommandList+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.D2d1.ID2D1CommandList](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1CommandList)  
[ID2D1CommandSink](https://www.google.com/search?num=5&q=ID2D1CommandSink+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1CommandSink](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1CommandSink)  
[ID2D1DCRenderTarget](https://www.google.com/search?num=5&q=ID2D1DCRenderTarget+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1DCRenderTarget](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1DCRenderTarget)  
[ID2D1Device](https://www.google.com/search?num=5&q=ID2D1Device+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1Device](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Device)  
[ID2D1DeviceContext](https://www.google.com/search?num=5&q=ID2D1DeviceContext+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1DeviceContext](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1DeviceContext)  
[ID2D1DrawingStateBlock](https://www.google.com/search?num=5&q=ID2D1DrawingStateBlock+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1DrawingStateBlock](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1DrawingStateBlock)  
[ID2D1Effect](https://www.google.com/search?num=5&q=ID2D1Effect+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1Effect](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Effect)  
[ID2D1EllipseGeometry](https://www.google.com/search?num=5&q=ID2D1EllipseGeometry+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1EllipseGeometry](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1EllipseGeometry)  
[ID2D1Factory](https://www.google.com/search?num=5&q=ID2D1Factory+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1Factory](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Factory)  
[ID2D1GdiMetafile](https://www.google.com/search?num=5&q=ID2D1GdiMetafile+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1GdiMetafile](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1GdiMetafile)  
[ID2D1GdiMetafileSink](https://www.google.com/search?num=5&q=ID2D1GdiMetafileSink+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1GdiMetafileSink](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1GdiMetafileSink)  
[ID2D1Geometry](https://www.google.com/search?num=5&q=ID2D1Geometry+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1Geometry](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Geometry)  
[ID2D1GeometryGroup](https://www.google.com/search?num=5&q=ID2D1GeometryGroup+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1GeometryGroup](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1GeometryGroup)  
[ID2D1GeometrySink](https://www.google.com/search?num=5&q=ID2D1GeometrySink+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1GeometrySink](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1GeometrySink)  
[ID2D1GradientStopCollection](https://www.google.com/search?num=5&q=ID2D1GradientStopCollection+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1GradientStopCollection](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1GradientStopCollection)  
[ID2D1GradientStopCollection1](https://www.google.com/search?num=5&q=ID2D1GradientStopCollection1+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1GradientStopCollection1](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1GradientStopCollection1)  
[ID2D1HwndRenderTarget](https://www.google.com/search?num=5&q=ID2D1HwndRenderTarget+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1HwndRenderTarget](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1HwndRenderTarget)  
[ID2D1Image](https://www.google.com/search?num=5&q=ID2D1Image+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1Image](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Image)  
[ID2D1ImageBrush](https://www.google.com/search?num=5&q=ID2D1ImageBrush+site%3Alearn.microsoft.com) | d2d1_1.h | [Vanara.PInvoke.D2d1.ID2D1ImageBrush](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1ImageBrush)  
[ID2D1Layer](https://www.google.com/search?num=5&q=ID2D1Layer+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1Layer](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Layer)  
[ID2D1LinearGradientBrush](https://www.google.com/search?num=5&q=ID2D1LinearGradientBrush+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1LinearGradientBrush](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1LinearGradientBrush)  
[ID2D1Mesh](https://www.google.com/search?num=5&q=ID2D1Mesh+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1Mesh](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Mesh)  
[ID2D1PathGeometry](https://www.google.com/search?num=5&q=ID2D1PathGeometry+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1PathGeometry](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1PathGeometry)  
[ID2D1PrintControl](https://www.google.com/search?num=5&q=ID2D1PrintControl+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.D2d1.ID2D1PrintControl](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1PrintControl)  
[ID2D1Properties](https://www.google.com/search?num=5&q=ID2D1Properties+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.D2d1.ID2D1Properties](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Properties)  
[ID2D1RadialGradientBrush](https://www.google.com/search?num=5&q=ID2D1RadialGradientBrush+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1RadialGradientBrush](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1RadialGradientBrush)  
[ID2D1RectangleGeometry](https://www.google.com/search?num=5&q=ID2D1RectangleGeometry+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1RectangleGeometry](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1RectangleGeometry)  
[ID2D1RenderTarget](https://www.google.com/search?num=5&q=ID2D1RenderTarget+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1RenderTarget](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1RenderTarget)  
[ID2D1Resource](https://www.google.com/search?num=5&q=ID2D1Resource+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1Resource](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1Resource)  
[ID2D1RoundedRectangleGeometry](https://www.google.com/search?num=5&q=ID2D1RoundedRectangleGeometry+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1RoundedRectangleGeometry](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1RoundedRectangleGeometry)  
[ID2D1SimplifiedGeometrySink](https://www.google.com/search?num=5&q=ID2D1SimplifiedGeometrySink+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1SimplifiedGeometrySink](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1SimplifiedGeometrySink)  
[ID2D1SolidColorBrush](https://www.google.com/search?num=5&q=ID2D1SolidColorBrush+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1SolidColorBrush](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1SolidColorBrush)  
[ID2D1StrokeStyle](https://www.google.com/search?num=5&q=ID2D1StrokeStyle+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1StrokeStyle](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1StrokeStyle)  
[ID2D1TessellationSink](https://www.google.com/search?num=5&q=ID2D1TessellationSink+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1TessellationSink](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1TessellationSink)  
[ID2D1TransformedGeometry](https://www.google.com/search?num=5&q=ID2D1TransformedGeometry+site%3Alearn.microsoft.com) | d2d1.h | [Vanara.PInvoke.D2d1.ID2D1TransformedGeometry](https://github.com/dahall/Vanara/search?l=C%23&q=ID2D1TransformedGeometry)  
[IDWriteBitmapRenderTarget](https://www.google.com/search?num=5&q=IDWriteBitmapRenderTarget+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteBitmapRenderTarget](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteBitmapRenderTarget)  
[IDWriteFactory](https://www.google.com/search?num=5&q=IDWriteFactory+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFactory](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFactory)  
[IDWriteFont](https://www.google.com/search?num=5&q=IDWriteFont+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFont](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFont)  
[IDWriteFontCollection](https://www.google.com/search?num=5&q=IDWriteFontCollection+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFontCollection](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFontCollection)  
[IDWriteFontCollectionLoader](https://www.google.com/search?num=5&q=IDWriteFontCollectionLoader+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFontCollectionLoader](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFontCollectionLoader)  
[IDWriteFontFace](https://www.google.com/search?num=5&q=IDWriteFontFace+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFontFace](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFontFace)  
[IDWriteFontFamily](https://www.google.com/search?num=5&q=IDWriteFontFamily+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFontFamily](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFontFamily)  
[IDWriteFontFile](https://www.google.com/search?num=5&q=IDWriteFontFile+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFontFile](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFontFile)  
[IDWriteFontFileEnumerator](https://www.google.com/search?num=5&q=IDWriteFontFileEnumerator+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFontFileEnumerator](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFontFileEnumerator)  
[IDWriteFontFileLoader](https://www.google.com/search?num=5&q=IDWriteFontFileLoader+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFontFileLoader](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFontFileLoader)  
[IDWriteFontFileStream](https://www.google.com/search?num=5&q=IDWriteFontFileStream+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFontFileStream](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFontFileStream)  
[IDWriteFontList](https://www.google.com/search?num=5&q=IDWriteFontList+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteFontList](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteFontList)  
[IDWriteGdiInterop](https://www.google.com/search?num=5&q=IDWriteGdiInterop+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteGdiInterop](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteGdiInterop)  
[IDWriteGlyphRunAnalysis](https://www.google.com/search?num=5&q=IDWriteGlyphRunAnalysis+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteGlyphRunAnalysis](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteGlyphRunAnalysis)  
[IDWriteInlineObject](https://www.google.com/search?num=5&q=IDWriteInlineObject+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteInlineObject](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteInlineObject)  
[IDWriteLocalFontFileLoader](https://www.google.com/search?num=5&q=IDWriteLocalFontFileLoader+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteLocalFontFileLoader](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteLocalFontFileLoader)  
[IDWriteLocalizedStrings](https://www.google.com/search?num=5&q=IDWriteLocalizedStrings+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteLocalizedStrings](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteLocalizedStrings)  
[IDWriteNumberSubstitution](https://www.google.com/search?num=5&q=IDWriteNumberSubstitution+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Dwrite.IDWriteNumberSubstitution](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteNumberSubstitution)  
[IDWritePixelSnapping](https://www.google.com/search?num=5&q=IDWritePixelSnapping+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWritePixelSnapping](https://github.com/dahall/Vanara/search?l=C%23&q=IDWritePixelSnapping)  
[IDWriteRenderingParams](https://www.google.com/search?num=5&q=IDWriteRenderingParams+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteRenderingParams](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteRenderingParams)  
[IDWriteTextAnalysisSink](https://www.google.com/search?num=5&q=IDWriteTextAnalysisSink+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteTextAnalysisSink](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteTextAnalysisSink)  
[IDWriteTextAnalysisSource](https://www.google.com/search?num=5&q=IDWriteTextAnalysisSource+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteTextAnalysisSource](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteTextAnalysisSource)  
[IDWriteTextAnalyzer](https://www.google.com/search?num=5&q=IDWriteTextAnalyzer+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteTextAnalyzer](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteTextAnalyzer)  
[IDWriteTextFormat](https://www.google.com/search?num=5&q=IDWriteTextFormat+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteTextFormat](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteTextFormat)  
[IDWriteTextLayout](https://www.google.com/search?num=5&q=IDWriteTextLayout+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteTextLayout](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteTextLayout)  
[IDWriteTextRenderer](https://www.google.com/search?num=5&q=IDWriteTextRenderer+site%3Alearn.microsoft.com) | dwrite.h | [Vanara.PInvoke.Dwrite.IDWriteTextRenderer](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteTextRenderer)  
[IDWriteTypography](https://www.google.com/search?num=5&q=IDWriteTypography+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Dwrite.IDWriteTypography](https://github.com/dahall/Vanara/search?l=C%23&q=IDWriteTypography)  
[IDXGIAdapter](https://www.google.com/search?num=5&q=IDXGIAdapter+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.IDXGIAdapter](https://github.com/dahall/Vanara/search?l=C%23&q=IDXGIAdapter)  
[IDXGIAdapter1](https://www.google.com/search?num=5&q=IDXGIAdapter1+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.IDXGIAdapter1](https://github.com/dahall/Vanara/search?l=C%23&q=IDXGIAdapter1)  
[IDXGIDevice](https://www.google.com/search?num=5&q=IDXGIDevice+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.IDXGIDevice](https://github.com/dahall/Vanara/search?l=C%23&q=IDXGIDevice)  
[IDXGIDeviceSubObject](https://www.google.com/search?num=5&q=IDXGIDeviceSubObject+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.DXGI.IDXGIDeviceSubObject](https://github.com/dahall/Vanara/search?l=C%23&q=IDXGIDeviceSubObject)  
[IDXGIFactory](https://www.google.com/search?num=5&q=IDXGIFactory+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.IDXGIFactory](https://github.com/dahall/Vanara/search?l=C%23&q=IDXGIFactory)  
[IDXGIFactory1](https://www.google.com/search?num=5&q=IDXGIFactory1+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.DXGI.IDXGIFactory1](https://github.com/dahall/Vanara/search?l=C%23&q=IDXGIFactory1)  
[IDXGIObject](https://www.google.com/search?num=5&q=IDXGIObject+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.DXGI.IDXGIObject](https://github.com/dahall/Vanara/search?l=C%23&q=IDXGIObject)  
[IDXGIOutput](https://www.google.com/search?num=5&q=IDXGIOutput+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.IDXGIOutput](https://github.com/dahall/Vanara/search?l=C%23&q=IDXGIOutput)  
[IDXGISurface](https://www.google.com/search?num=5&q=IDXGISurface+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.IDXGISurface](https://github.com/dahall/Vanara/search?l=C%23&q=IDXGISurface)  
[IDXGISwapChain](https://www.google.com/search?num=5&q=IDXGISwapChain+site%3Alearn.microsoft.com) | dxgi.h | [Vanara.PInvoke.DXGI.IDXGISwapChain](https://github.com/dahall/Vanara/search?l=C%23&q=IDXGISwapChain)  
[IWICBitmap](https://www.google.com/search?num=5&q=IWICBitmap+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmap](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmap)  
[IWICBitmapClipper](https://www.google.com/search?num=5&q=IWICBitmapClipper+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapClipper](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapClipper)  
[IWICBitmapCodecInfo](https://www.google.com/search?num=5&q=IWICBitmapCodecInfo+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapCodecInfo](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapCodecInfo)  
[IWICBitmapCodecProgressNotification](https://www.google.com/search?num=5&q=IWICBitmapCodecProgressNotification+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.WindowsCodecs.IWICBitmapCodecProgressNotification](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapCodecProgressNotification)  
[IWICBitmapDecoder](https://www.google.com/search?num=5&q=IWICBitmapDecoder+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapDecoder](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapDecoder)  
[IWICBitmapDecoderInfo](https://www.google.com/search?num=5&q=IWICBitmapDecoderInfo+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapDecoderInfo](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapDecoderInfo)  
[IWICBitmapEncoder](https://www.google.com/search?num=5&q=IWICBitmapEncoder+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapEncoder](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapEncoder)  
[IWICBitmapEncoderInfo](https://www.google.com/search?num=5&q=IWICBitmapEncoderInfo+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapEncoderInfo](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapEncoderInfo)  
[IWICBitmapFlipRotator](https://www.google.com/search?num=5&q=IWICBitmapFlipRotator+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapFlipRotator](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapFlipRotator)  
[IWICBitmapFrameDecode](https://www.google.com/search?num=5&q=IWICBitmapFrameDecode+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapFrameDecode](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapFrameDecode)  
[IWICBitmapFrameEncode](https://www.google.com/search?num=5&q=IWICBitmapFrameEncode+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapFrameEncode](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapFrameEncode)  
[IWICBitmapLock](https://www.google.com/search?num=5&q=IWICBitmapLock+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapLock](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapLock)  
[IWICBitmapScaler](https://www.google.com/search?num=5&q=IWICBitmapScaler+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapScaler](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapScaler)  
[IWICBitmapSource](https://www.google.com/search?num=5&q=IWICBitmapSource+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapSource](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapSource)  
[IWICBitmapSourceTransform](https://www.google.com/search?num=5&q=IWICBitmapSourceTransform+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICBitmapSourceTransform](https://github.com/dahall/Vanara/search?l=C%23&q=IWICBitmapSourceTransform)  
[IWICColorContext](https://www.google.com/search?num=5&q=IWICColorContext+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICColorContext](https://github.com/dahall/Vanara/search?l=C%23&q=IWICColorContext)  
[IWICColorTransform](https://www.google.com/search?num=5&q=IWICColorTransform+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICColorTransform](https://github.com/dahall/Vanara/search?l=C%23&q=IWICColorTransform)  
[IWICComponentFactory](https://www.google.com/search?num=5&q=IWICComponentFactory+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.IWICComponentFactory](https://github.com/dahall/Vanara/search?l=C%23&q=IWICComponentFactory)  
[IWICComponentInfo](https://www.google.com/search?num=5&q=IWICComponentInfo+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICComponentInfo](https://github.com/dahall/Vanara/search?l=C%23&q=IWICComponentInfo)  
[IWICDdsDecoder](https://www.google.com/search?num=5&q=IWICDdsDecoder+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICDdsDecoder](https://github.com/dahall/Vanara/search?l=C%23&q=IWICDdsDecoder)  
[IWICDdsEncoder](https://www.google.com/search?num=5&q=IWICDdsEncoder+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICDdsEncoder](https://github.com/dahall/Vanara/search?l=C%23&q=IWICDdsEncoder)  
[IWICDdsFrameDecode](https://www.google.com/search?num=5&q=IWICDdsFrameDecode+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICDdsFrameDecode](https://github.com/dahall/Vanara/search?l=C%23&q=IWICDdsFrameDecode)  
[IWICDevelopRaw](https://www.google.com/search?num=5&q=IWICDevelopRaw+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICDevelopRaw](https://github.com/dahall/Vanara/search?l=C%23&q=IWICDevelopRaw)  
[IWICDevelopRawNotificationCallback](https://www.google.com/search?num=5&q=IWICDevelopRawNotificationCallback+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICDevelopRawNotificationCallback](https://github.com/dahall/Vanara/search?l=C%23&q=IWICDevelopRawNotificationCallback)  
[IWICEnumMetadataItem](https://www.google.com/search?num=5&q=IWICEnumMetadataItem+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICEnumMetadataItem](https://github.com/dahall/Vanara/search?l=C%23&q=IWICEnumMetadataItem)  
[IWICFastMetadataEncoder](https://www.google.com/search?num=5&q=IWICFastMetadataEncoder+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICFastMetadataEncoder](https://github.com/dahall/Vanara/search?l=C%23&q=IWICFastMetadataEncoder)  
[IWICFormatConverter](https://www.google.com/search?num=5&q=IWICFormatConverter+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICFormatConverter](https://github.com/dahall/Vanara/search?l=C%23&q=IWICFormatConverter)  
[IWICFormatConverterInfo](https://www.google.com/search?num=5&q=IWICFormatConverterInfo+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICFormatConverterInfo](https://github.com/dahall/Vanara/search?l=C%23&q=IWICFormatConverterInfo)  
[IWICImageEncoder](https://www.google.com/search?num=5&q=IWICImageEncoder+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICImageEncoder](https://github.com/dahall/Vanara/search?l=C%23&q=IWICImageEncoder)  
[IWICImagingFactory](https://www.google.com/search?num=5&q=IWICImagingFactory+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICImagingFactory](https://github.com/dahall/Vanara/search?l=C%23&q=IWICImagingFactory)  
[IWICImagingFactory2](https://www.google.com/search?num=5&q=IWICImagingFactory2+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICImagingFactory2](https://github.com/dahall/Vanara/search?l=C%23&q=IWICImagingFactory2)  
[IWICJpegFrameDecode](https://www.google.com/search?num=5&q=IWICJpegFrameDecode+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICJpegFrameDecode](https://github.com/dahall/Vanara/search?l=C%23&q=IWICJpegFrameDecode)  
[IWICJpegFrameEncode](https://www.google.com/search?num=5&q=IWICJpegFrameEncode+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICJpegFrameEncode](https://github.com/dahall/Vanara/search?l=C%23&q=IWICJpegFrameEncode)  
[IWICMetadataBlockReader](https://www.google.com/search?num=5&q=IWICMetadataBlockReader+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.IWICMetadataBlockReader](https://github.com/dahall/Vanara/search?l=C%23&q=IWICMetadataBlockReader)  
[IWICMetadataBlockWriter](https://www.google.com/search?num=5&q=IWICMetadataBlockWriter+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.IWICMetadataBlockWriter](https://github.com/dahall/Vanara/search?l=C%23&q=IWICMetadataBlockWriter)  
[IWICMetadataHandlerInfo](https://www.google.com/search?num=5&q=IWICMetadataHandlerInfo+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.WindowsCodecs.IWICMetadataHandlerInfo](https://github.com/dahall/Vanara/search?l=C%23&q=IWICMetadataHandlerInfo)  
[IWICMetadataQueryReader](https://www.google.com/search?num=5&q=IWICMetadataQueryReader+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICMetadataQueryReader](https://github.com/dahall/Vanara/search?l=C%23&q=IWICMetadataQueryReader)  
[IWICMetadataQueryWriter](https://www.google.com/search?num=5&q=IWICMetadataQueryWriter+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICMetadataQueryWriter](https://github.com/dahall/Vanara/search?l=C%23&q=IWICMetadataQueryWriter)  
[IWICMetadataReader](https://www.google.com/search?num=5&q=IWICMetadataReader+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.IWICMetadataReader](https://github.com/dahall/Vanara/search?l=C%23&q=IWICMetadataReader)  
[IWICMetadataReaderInfo](https://www.google.com/search?num=5&q=IWICMetadataReaderInfo+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.IWICMetadataReaderInfo](https://github.com/dahall/Vanara/search?l=C%23&q=IWICMetadataReaderInfo)  
[IWICMetadataWriter](https://www.google.com/search?num=5&q=IWICMetadataWriter+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.IWICMetadataWriter](https://github.com/dahall/Vanara/search?l=C%23&q=IWICMetadataWriter)  
[IWICMetadataWriterInfo](https://www.google.com/search?num=5&q=IWICMetadataWriterInfo+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.IWICMetadataWriterInfo](https://github.com/dahall/Vanara/search?l=C%23&q=IWICMetadataWriterInfo)  
[IWICPalette](https://www.google.com/search?num=5&q=IWICPalette+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICPalette](https://github.com/dahall/Vanara/search?l=C%23&q=IWICPalette)  
[IWICPersistStream](https://www.google.com/search?num=5&q=IWICPersistStream+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.IWICPersistStream](https://github.com/dahall/Vanara/search?l=C%23&q=IWICPersistStream)  
[IWICPixelFormatInfo](https://www.google.com/search?num=5&q=IWICPixelFormatInfo+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICPixelFormatInfo](https://github.com/dahall/Vanara/search?l=C%23&q=IWICPixelFormatInfo)  
[IWICPixelFormatInfo2](https://www.google.com/search?num=5&q=IWICPixelFormatInfo2+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICPixelFormatInfo2](https://github.com/dahall/Vanara/search?l=C%23&q=IWICPixelFormatInfo2)  
[IWICPlanarBitmapFrameEncode](https://www.google.com/search?num=5&q=IWICPlanarBitmapFrameEncode+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICPlanarBitmapFrameEncode](https://github.com/dahall/Vanara/search?l=C%23&q=IWICPlanarBitmapFrameEncode)  
[IWICPlanarBitmapSourceTransform](https://www.google.com/search?num=5&q=IWICPlanarBitmapSourceTransform+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.WindowsCodecs.IWICPlanarBitmapSourceTransform](https://github.com/dahall/Vanara/search?l=C%23&q=IWICPlanarBitmapSourceTransform)  
[IWICPlanarFormatConverter](https://www.google.com/search?num=5&q=IWICPlanarFormatConverter+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICPlanarFormatConverter](https://github.com/dahall/Vanara/search?l=C%23&q=IWICPlanarFormatConverter)  
[IWICProgressCallback](https://www.google.com/search?num=5&q=IWICProgressCallback+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICProgressCallback](https://github.com/dahall/Vanara/search?l=C%23&q=IWICProgressCallback)  
[IWICProgressiveLevelControl](https://www.google.com/search?num=5&q=IWICProgressiveLevelControl+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICProgressiveLevelControl](https://github.com/dahall/Vanara/search?l=C%23&q=IWICProgressiveLevelControl)  
[IWICStream](https://www.google.com/search?num=5&q=IWICStream+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.IWICStream](https://github.com/dahall/Vanara/search?l=C%23&q=IWICStream)  
[IWICStreamProvider](https://www.google.com/search?num=5&q=IWICStreamProvider+site%3Alearn.microsoft.com) | wincodecsdk.h | [Vanara.PInvoke.WindowsCodecs.IWICStreamProvider](https://github.com/dahall/Vanara/search?l=C%23&q=IWICStreamProvider)  
### Classes  
Native Class | Header | Managed Class  
--- | --- | ---  
[PWICRect](https://www.google.com/search?num=5&q=PWICRect+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.PWICRect](https://github.com/dahall/Vanara/search?l=C%23&q=PWICRect)  
[WICGuids](https://www.google.com/search?num=5&q=WICGuids+site%3Alearn.microsoft.com) | wincodec.h | [Vanara.PInvoke.WindowsCodecs.WICGuids](https://github.com/dahall/Vanara/search?l=C%23&q=WICGuids)  
