﻿![Vanara](https://raw.githubusercontent.com/dahall/Vanara/master/docs/icons/VanaraHeading.png)
### **Vanara.PInvoke.P2P NuGet Package**
[![Version](https://img.shields.io/nuget/v/Vanara.PInvoke.P2P?label=NuGet&style=flat-square)](https://github.com/dahall/Vanara/releases)
[![Build status](https://img.shields.io/appveyor/build/dahall/vanara?label=AppVeyor%20build&style=flat-square)](https://ci.appveyor.com/project/dahall/vanara)

PInvoke API (methods, structures and constants) imported from Windows P2P.dll for Peer-to-Peer API.

### **What is Vanara?**

[Vanara](https://github.com/dahall/Vanara) is a community project that contains various .NET assemblies which have P/Invoke functions, interfaces, enums and structures from Windows libraries. Each assembly is associated with one or a few tightly related libraries.

### **Issues?**

First check if it's already fixed by trying the [AppVeyor build](https://ci.appveyor.com/nuget/vanara-prerelease).
If you're still running into problems, file an [issue](https://github.com/dahall/Vanara/issues).

### **Included in Vanara.PInvoke.P2P**

Functions | Enumerations | Structures
--- | --- | ---
PeerCollabAddContact PeerCollabAsyncInviteContact PeerCollabAsyncInviteEndpoint PeerCollabCancelInvitation PeerCollabCloseHandle PeerCollabDeleteContact PeerCollabDeleteEndpointData PeerCollabDeleteObject PeerCollabEnumApplicationRegistrationInfo PeerCollabEnumApplications PeerCollabEnumContacts PeerCollabEnumEndpoints PeerCollabEnumObjects PeerCollabEnumPeopleNearMe PeerCollabExportContact PeerCollabGetAppLaunchInfo PeerCollabGetApplicationRegistrationInfo PeerCollabGetContact PeerCollabGetEndpointName PeerCollabGetEventData PeerCollabGetInvitationResponse PeerCollabGetPresenceInfo PeerCollabGetSigninOptions PeerCollabInviteContact PeerCollabInviteEndpoint PeerCollabParseContact PeerCollabQueryContactData PeerCollabRefreshEndpointData PeerCollabRegisterApplication PeerCollabRegisterEvent PeerCollabSetEndpointName PeerCollabSetObject PeerCollabSetPresenceInfo PeerCollabShutdown PeerCollabSignin PeerCollabSignout PeerCollabStartup PeerCollabSubscribeEndpointData PeerCollabUnregisterApplication PeerCollabUnregisterEvent PeerCollabUnsubscribeEndpointData PeerCollabUpdateContact PeerCreatePeerName PeerEndEnumeration PeerEnumGroups PeerEnumIdentities PeerFreeData PeerGetItemCount PeerGetNextItem PeerGraphShutdown PeerGraphStartup PeerGroupAddRecord PeerGroupClose PeerGroupCloseDirectConnection PeerGroupConnect PeerGroupConnectByAddress PeerGroupCreate PeerGroupCreateInvitation PeerGroupCreatePasswordInvitation PeerGroupDelete PeerGroupDeleteRecord PeerGroupEnumConnections PeerGroupEnumMembers PeerGroupEnumRecords PeerGroupExportConfig PeerGroupExportDatabase PeerGroupGetEventData PeerGroupGetProperties PeerGroupGetRecord PeerGroupGetStatus PeerGroupImportConfig PeerGroupImportDatabase PeerGroupIssueCredentials PeerGroupJoin PeerGroupOpen PeerGroupOpenDirectConnection PeerGroupParseInvitation PeerGroupPasswordJoin PeerGroupPeerTimeToUniversalTime PeerGroupRegisterEvent PeerGroupSearchRecords PeerGroupSendData PeerGroupSetProperties PeerGroupShutdown PeerGroupStartup PeerGroupUniversalTimeToPeerTime PeerGroupUnregisterEvent PeerGroupUpdateRecord PeerHostNameToPeerName PeerIdentityCreate PeerIdentityDelete PeerIdentityExport PeerIdentityGetCryptKey PeerIdentityGetDefault PeerIdentityGetFriendlyName PeerIdentityGetXML PeerIdentityImport PeerIdentitySetFriendlyName PeerNameToPeerHostName PeerPnrpEndResolve PeerPnrpGetCloudInfo PeerPnrpGetEndpoint PeerPnrpRegister PeerPnrpResolve PeerPnrpShutdown PeerPnrpStartResolve PeerPnrpStartup PeerPnrpUnregister PeerPnrpUpdateRegistration  | PEER_APPLICATION_REGISTRATION_TYPE PEER_CHANGE_TYPE PEER_COLLAB_EVENT_TYPE PEER_CONNECTION_FLAGS PEER_CONNECTION_STATUS PEER_GRAPH_EVENT_TYPE PEER_GRAPH_PROPERTY_FLAGS PEER_GRAPH_SCOPE PEER_GRAPH_STATUS_FLAGS PEER_GROUP_AUTHENTICATION_SCHEME PEER_GROUP_EVENT_TYPE PEER_GROUP_ISSUE_CREDENTIAL_FLAGS PEER_GROUP_PROPERTY_FLAGS PEER_GROUP_STATUS PEER_INVITATION_RESPONSE_TYPE PEER_MEMBER_CHANGE_TYPE PEER_MEMBER_FLAGS PEER_NODE_CHANGE_TYPE PEER_PRESENCE_STATUS PEER_PUBLICATION_SCOPE PEER_RECORD_CHANGE_TYPE PEER_RECORD_FLAGS PEER_SIGNIN_FLAGS PEER_WATCH_PERMISSION PNRP_CLOUD_FLAGS PNRP_CLOUD_STATE PNRP_EXTENDED_PAYLOAD_TYPE PNRP_REGISTERED_ID_STATE PNRP_RESOLVE_CRITERIA PNRP_SCOPE PNRPINFO_FLAGS                                                                                | HPEEREVENT HGRAPH PEER_ADDRESS PEER_APP_LAUNCH_INFO PEER_APPLICATION PEER_APPLICATION_REGISTRATION_INFO PEER_COLLAB_EVENT_DATA PEER_COLLAB_EVENT_REGISTRATION PEER_CONNECTION_INFO PEER_CONTACT PEER_CREDENTIAL_INFO PEER_DATA PEER_ENDPOINT PEER_EVENT_APPLICATION_CHANGED_DATA PEER_EVENT_CONNECTION_CHANGE_DATA PEER_EVENT_ENDPOINT_CHANGED_DATA PEER_EVENT_INCOMING_DATA PEER_EVENT_MEMBER_CHANGE_DATA PEER_EVENT_NODE_CHANGE_DATA PEER_EVENT_OBJECT_CHANGED_DATA PEER_EVENT_PEOPLE_NEAR_ME_CHANGED_DATA PEER_EVENT_PRESENCE_CHANGED_DATA PEER_EVENT_RECORD_CHANGE_DATA PEER_EVENT_REQUEST_STATUS_CHANGED_DATA PEER_EVENT_SYNCHRONIZED_DATA PEER_EVENT_WATCHLIST_CHANGED_DATA PEER_GRAPH_EVENT_DATA PEER_GRAPH_EVENT_REGISTRATION PEER_GRAPH_PROPERTIES PEER_GROUP_EVENT_DATA PEER_GROUP_EVENT_REGISTRATION PEER_GROUP_PROPERTIES PEER_INVITATION PEER_INVITATION_INFO PEER_INVITATION_RESPONSE PEER_MEMBER PEER_NAME_PAIR PEER_NODE_INFO PEER_OBJECT PEER_PEOPLE_NEAR_ME PEER_PNRP_CLOUD_INFO PEER_PNRP_ENDPOINT_INFO PEER_PNRP_REGISTRATION_INFO PEER_PRESENCE_INFO PEER_RECORD PEER_SECURITY_INTERFACE PEER_VERSION_DATA HPEERENUM HREGISTRATION HRESOLUTION HGROUP PNRP_CLOUD_ID PNRPCLOUDINFO PNRPINFO_V1 PNRPINFO_V2                                                       
