﻿![Vanara](https://raw.githubusercontent.com/dahall/Vanara/master/docs/icons/VanaraHeading.png)
### **Vanara.PInvoke.Gdi32 NuGet Package**
[![Version](https://img.shields.io/nuget/v/Vanara.PInvoke.Gdi32?label=NuGet&style=flat-square)](https://github.com/dahall/Vanara/releases)
[![Build status](https://img.shields.io/appveyor/build/dahall/vanara?label=AppVeyor%20build&style=flat-square)](https://ci.appveyor.com/project/dahall/vanara)

PInvoke API (methods, structures and constants) imported from Windows Gdi32.dll

### **What is Vanara?**

[Vanara](https://github.com/dahall/Vanara) is a community project that contains various .NET assemblies which have P/Invoke functions, interfaces, enums and structures from Windows libraries. Each assembly is associated with one or a few tightly related libraries.

### **Issues?**

First check if it's already fixed by trying the [AppVeyor build](https://ci.appveyor.com/nuget/vanara-prerelease).
If you're still running into problems, file an [issue](https://github.com/dahall/Vanara/issues).

### **Included in Vanara.PInvoke.Gdi32**

Functions | Enumerations | Structures
--- | --- | ---
AbortDoc AbortPath AddFontMemResourceEx AddFontResource AddFontResourceEx AngleArc AnimatePalette Arc ArcTo BeginPath BitBlt CancelDC CheckColorsInGamut ChoosePixelFormat Chord CloseEnhMetaFile CloseFigure CloseMetaFile ColorCorrectPalette ColorMatchToTarget CombineRgn CombineTransform CopyEnhMetaFile CopyMetaFile CreateBitmap CreateBitmapIndirect CreateBrushIndirect CreateColorSpace CreateCompatibleBitmap CreateCompatibleDC CreateDC CreateDIBitmap CreateDIBPatternBrush CreateDIBPatternBrushPt CreateDIBSection CreateDiscardableBitmap CreateEllipticRgn CreateEllipticRgnIndirect CreateEnhMetaFile CreateFont CreateFontIndirect CreateFontIndirectEx CreateHalftonePalette CreateHatchBrush CreateIC CreateMetaFile CreatePalette CreatePatternBrush CreatePen CreatePenIndirect CreatePolygonRgn CreatePolyPolygonRgn CreateRectRgn CreateRectRgnIndirect CreateRoundRectRgn CreateScalableFontResource CreateSolidBrush DeleteColorSpace DeleteDC DeleteEnhMetaFile DeleteMetaFile DeleteObject DescribePixelFormat DPtoLP DrawEscape Ellipse EnableEUDC EndDoc EndPage EndPath EnumEnhMetaFile EnumFontFamilies EnumFontFamiliesEx EnumFonts EnumICMProfiles EnumMetaFile EnumObjects EqualRgn Escape ExcludeClipRect ExtCreatePen ExtCreateRegion ExtEscape ExtFloodFill ExtSelectClipRgn ExtTextOut FillPath FillRgn FlattenPath FloodFill FrameRgn GdiAlphaBlend GdiComment GdiDeleteSpoolFileHandle GdiEndDocEMF GdiEndPageEMF GdiFlush GdiGetBatchLimit GdiGetDC GdiGetDevmodeForPage GdiGetPageCount GdiGetPageHandle GdiGetSpoolFileHandle GdiGradientFill GdiPlayPageEMF GdiResetDCEMF GdiSetBatchLimit GdiStartDocEMF GdiStartPageEMF GdiTransparentBlt GetArcDirection GetAspectRatioFilterEx GetBitmapBits GetBitmapDimensionEx GetBkColor GetBkMode GetBoundsRect GetBrushOrgEx GetCharABCWidths GetCharABCWidthsFloat GetCharABCWidthsI GetCharacterPlacement GetCharWidth GetCharWidth32 GetCharWidthFloat GetCharWidthI GetClipBox GetClipRgn GetColorAdjustment GetColorSpace GetCurrentObject GetCurrentPositionEx GetDCBrushColor GetDCOrgEx GetDCPenColor GetDeviceCaps GetDeviceGammaRamp GetDIBColorTable GetDIBits GetEnhMetaFile GetEnhMetaFileBits GetEnhMetaFileDescription GetEnhMetaFileHeader GetEnhMetaFilePaletteEntries GetEnhMetaFilePixelFormat GetFontData GetFontLanguageInfo GetFontUnicodeRanges GetGlyphIndices GetGlyphOutline GetGraphicsMode GetICMProfile GetKerningPairs GetLayout GetLogColorSpace GetMapMode GetMetaFileA GetMetaFileBitsEx GetMetaFileW GetMetaRgn GetMiterLimit GetNearestColor GetNearestPaletteIndex GetObject GetObjectType GetOutlineTextMetrics GetPaletteEntries GetPath GetPixel GetPixelFormat GetPolyFillMode GetRandomRgn GetRasterizerCaps GetRegionData GetRgnBox GetROP2 GetStockObject GetStretchBltMode GetSystemPaletteEntries GetSystemPaletteUse GetTextAlign GetTextCharacterExtra GetTextCharset GetTextCharsetInfo GetTextColor GetTextExtentExPoint GetTextExtentExPointI GetTextExtentPoint GetTextExtentPoint32 GetTextExtentPointI GetTextFace GetTextMetrics GetViewportExtEx GetViewportOrgEx GetWindowExtEx GetWindowOrgEx GetWinMetaFileBits GetWorldTransform GradientFillA IntersectClipRect InvertRgn LineDDA LineTo LPtoDP MaskBlt ModifyWorldTransform MoveToEx OffsetClipRgn OffsetRgn OffsetViewportOrgEx OffsetWindowOrgEx PaintRgn PatBlt PathToRegion Pie PlayEnhMetaFile PlayEnhMetaFileRecord PlayMetaFile PlayMetaFileRecord PlgBlt PolyBezier PolyBezierTo PolyDraw Polygon Polyline PolylineTo PolyPolygon PolyPolyline PolyTextOut PtInRegion PtVisible RealizePalette Rectangle RectInRegion RectVisible RemoveFontMemResourceEx RemoveFontResource RemoveFontResourceEx ResetDC ResizePalette RestoreDC RoundRect SaveDC ScaleViewportExtEx ScaleWindowExtEx SelectClipPath SelectClipRgn SelectObject SelectPalette SetAbortProc SetArcDirection SetBitmapBits SetBitmapDimensionEx SetBkColor SetBkMode SetBoundsRect SetBrushOrgEx SetColorAdjustment SetColorSpace SetDCBrushColor SetDCPenColor SetDeviceGammaRamp SetDIBColorTable SetDIBits SetDIBitsToDevice SetEnhMetaFileBits SetGraphicsMode SetICMMode SetICMProfile SetLayout SetMapMode SetMapperFlags SetMetaFileBitsEx SetMetaRgn SetMiterLimit SetPaletteEntries SetPixel SetPixelFormat SetPixelV SetPolyFillMode SetRectRgn SetROP2 SetStretchBltMode SetSystemPaletteUse SetTextAlign SetTextCharacterExtra SetTextColor SetTextJustification SetViewportExtEx SetViewportOrgEx SetWindowExtEx SetWindowOrgEx SetWinMetaFileBits SetWorldTransform StartDoc StartPage StretchBlt StretchDIBits StrokeAndFillPath StrokePath SwapBuffers TextOut TranslateCharsetInfo UnrealizeObject UpdateColors WidenPath  | CBM DIBColorMode FloodFillType GradientFillMode RasterOperationMode StretchMode BitmapCompressionMode RegionFlags RegionOp CA_FLAGS CS ICM ILLUMINANT LCSCSTYPE LCSGAMUTMATCH SYSPAL GraphicsMode MapMode MWT BrushStyle DCLayout DISPLAY_DEVICE_FLAGS HatchStyle TCI DeviceCap ObjType StockObjectType DISPLAYCONFIG_COLOR_ENCODING DISPLAYCONFIG_DEVICE_INFO_TYPE DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO_VALUE DISPLAYCONFIG_MODE_INFO_TYPE DISPLAYCONFIG_PIXELFORMAT DISPLAYCONFIG_ROTATION DISPLAYCONFIG_SCALING DISPLAYCONFIG_SCANLINE_ORDERING DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE_VALUE DISPLAYCONFIG_SET_TARGET_PERSISTENCE_VALUE DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION_VALUE DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS DISPLAYCONFIG_TOPOLOGY_ID DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY D3DKMDT_VIDEO_SIGNAL_STANDARD BackgroundMode DCB R2 CharacterSetUint ClippingPrecision ETO FontType FR GCP GCPCLASS GGI GGO GSISize OutputPrecision OutputQuality PAN_ARMS PAN_CONTRAST PAN_FAMILY PAN_LETT PAN_MIDLINE PAN_PROP PAN_SERIF PAN_STROKE PAN_WEIGHT PAN_XHEIGHT PitchAndFamily TextAlign TT RecordType PFD_FLAGS PFD_LAYER PFD_TYPE VertexType PenEndCap PenJoin PenStyle PenType DI EscapeFunction PSINJECT RDH RGN_COMB RGN_FILLMODE RGN_TYPE ArcDirection                                                                                                                                                                                                                             | GRADIENT_RECT GRADIENT_TRIANGLE HSECTION TRIVERTEX BITMAP BITMAPCOREHEADER BITMAPCOREINFO BITMAPFILEHEADER BITMAPINFO BITMAPINFOHEADER BITMAPV4HEADER BITMAPV5HEADER DIBSECTION BLENDFUNCTION LOGBRUSH CIEXYZ CIEXYZTRIPLE COLORADJUSTMENT LOGCOLORSPACE RGBTRIPLE XFORM CHARSETINFO DISPLAY_DEVICE DISPLAYCONFIG_2DREGION DISPLAYCONFIG_ADAPTER_NAME DISPLAYCONFIG_DESKTOP_IMAGE_INFO DISPLAYCONFIG_DEVICE_INFO_HEADER DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO DISPLAYCONFIG_MODE_INFO DISPLAYCONFIG_PATH_INFO DISPLAYCONFIG_PATH_SOURCE_INFO DISPLAYCONFIG_PATH_TARGET_INFO DISPLAYCONFIG_RATIONAL DISPLAYCONFIG_SDR_WHITE_LEVEL DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE DISPLAYCONFIG_SET_TARGET_PERSISTENCE DISPLAYCONFIG_SOURCE_DEVICE_NAME DISPLAYCONFIG_SOURCE_MODE DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION DISPLAYCONFIG_TARGET_BASE_TYPE DISPLAYCONFIG_TARGET_DEVICE_NAME DISPLAYCONFIG_TARGET_MODE DISPLAYCONFIG_TARGET_PREFERRED_MODE DISPLAYCONFIG_VIDEO_SIGNAL_INFO ABC ABCFLOAT AXESLIST AXISINFO DESIGNVECTOR ENUMLOGFONT ENUMLOGFONTEX ENUMLOGFONTEXDV ENUMTEXTMETRIC FIXED FONTSIGNATURE GCP_RESULTS GLYPHMETRICS GLYPHSET KERNINGPAIR MAT2 NEWTEXTMETRIC NEWTEXTMETRICEX OUTLINETEXTMETRIC PANOSE POLYTEXT RASTERIZER_STATUS WCRANGE ENHMETAHEADER HANDLETABLE METAFILEPICT PIXELFORMATDESCRIPTOR EXTLOGPEN LOGPEN DOCINFO DRAWPATRECT PSFEATURE_CUSTPAPER PSFEATURE_OUTPUT PSINJECTDATA RGNDATAHEADER RGNDATA HSPOOLFILE Union Union                                                                                                                                                                                                                                
