﻿![Vanara](https://raw.githubusercontent.com/dahall/Vanara/master/docs/icons/VanaraHeading.png)
### **Vanara.PInvoke.Ole NuGet Package**
[![Version](https://img.shields.io/nuget/v/Vanara.PInvoke.Ole?label=NuGet&style=flat-square)](https://github.com/dahall/Vanara/releases)
[![Build status](https://img.shields.io/appveyor/build/dahall/vanara?label=AppVeyor%20build&style=flat-square)](https://ci.appveyor.com/project/dahall/vanara)

PInvoke API (methods, structures and constants) imported from Windows Ole32.dll, OleAut32 and PropSys.dll.

### **What is Vanara?**

[Vanara](https://github.com/dahall/Vanara) is a community project that contains various .NET assemblies which have P/Invoke functions, interfaces, enums and structures from Windows libraries. Each assembly is associated with one or a few tightly related libraries.

### **Issues?**

First check if it's already fixed by trying the [AppVeyor build](https://ci.appveyor.com/nuget/vanara-prerelease).
If you're still running into problems, file an [issue](https://github.com/dahall/Vanara/issues).

### **Included in Vanara.PInvoke.Ole**

Functions | Enumerations | Structures | Interfaces
--- | --- | --- | ---
BindMoniker BSTR_UserFree BSTR_UserFree64 BSTR_UserMarshal BSTR_UserMarshal64 BSTR_UserSize BSTR_UserSize64 BSTR_UserUnmarshal BSTR_UserUnmarshal64 BstrFromVector ClearCustData ClearPropVariantArray ClearVariantArray CLSIDFromProgID CLSIDFromProgIDEx CLSIDFromString CoAddRefServerProcess CoAllowSetForegroundWindow CoAllowUnmarshalerCLSID CoCancelCall CoCopyProxy CoCreateFreeThreadedMarshaler CoCreateGuid CoCreateInstance CoCreateInstanceEx CoCreateInstanceFromApp CoDecodeProxy CoDecrementMTAUsage CoDisableCallCancellation CoDisconnectContext CoDisconnectObject CoDosDateTimeToFileTime CoEnableCallCancellation CoFileTimeNow CoFileTimeToDosDateTime CoFreeAllLibraries CoFreeLibrary CoFreeUnusedLibraries CoFreeUnusedLibrariesEx CoGetApartmentType CoGetCallContext CoGetCallerTID CoGetCancelObject CoGetClassObject CoGetContextToken CoGetCurrentLogicalThreadId CoGetCurrentProcess CoGetDefaultContext CoGetInstanceFromFile CoGetInstanceFromIStorage CoGetInterceptor CoGetInterfaceAndReleaseStream CoGetMalloc CoGetMarshalSizeMax CoGetObject CoGetObjectContext CoGetPSClsid CoGetStandardMarshal CoGetStdMarshalEx CoGetSystemSecurityPermissions CoGetTreatAsClass CoHandlePriorityEventsFromMessagePump CoImpersonateClient CoIncrementMTAUsage CoInitialize CoInitializeEx CoInitializeSecurity CoInvalidateRemoteMachineBindings CoIsHandlerConnected CoIsOle1Class CoLoadLibrary CoLockObjectExternal CoMarshalHresult CoMarshalInterface CoMarshalInterThreadInterfaceInStream CoQueryAuthenticationServices CoQueryClientBlanket CoQueryProxyBlanket CoRegisterActivationFilter CoRegisterChannelHook CoRegisterClassObject CoRegisterInitializeSpy CoRegisterMallocSpy CoRegisterMessageFilter CoRegisterPSClsid CoRegisterSurrogate CoReleaseMarshalData CoReleaseServerProcess CoResumeClassObjects CoRevertToSelf CoRevokeClassObject CoRevokeInitializeSpy CoRevokeMallocSpy CoSetCancelObject CoSetMessageDispatcher CoSetProxyBlanket CoSuspendClassObjects CoSwitchCallContext CoTaskMemAlloc CoTaskMemFree CoTaskMemRealloc CoTestCancel CoTreatAsClass CoUninitialize CoUnmarshalHresult CoUnmarshalInterface CoWaitForMultipleHandles CoWaitForMultipleObjects CreateAntiMoniker CreateBindCtx CreateClassMoniker CreateDataAdviseHolder CreateDataCache CreateDispTypeInfo CreateErrorInfo CreateFileMoniker CreateGenericComposite CreateILockBytesOnHGlobal CreateItemMoniker CreateObjrefMoniker CreateOleAdviseHolder CreatePointerMoniker CreateStdDispatch CreateStreamOnHGlobal CreateTypeLib CreateTypeLib2 DispCallFunc DispGetIDsOfNames DispGetParam DispInvoke DllCanUnloadNow DllGetClassObject DllRegisterServer DllUnregisterServer DoDragDrop DosDateTimeToVariantTime FmtIdToPropStgName FreePropVariantArray GetActiveObject GetAltMonthNames GetClassFile GetConvertStg GetErrorInfo GetHGlobalFromILockBytes GetHGlobalFromStream GetRecordInfoFromGuids GetRecordInfoFromTypeInfo GetRunningObjectTable IIDFromString InitPropVariantFromBooleanVector InitPropVariantFromBuffer InitPropVariantFromCLSID InitPropVariantFromDoubleVector InitPropVariantFromFileTime InitPropVariantFromFileTimeVector InitPropVariantFromGUIDAsString InitPropVariantFromInt16Vector InitPropVariantFromInt32Vector InitPropVariantFromInt64Vector InitPropVariantFromPropVariantVectorElem InitPropVariantFromResource InitPropVariantFromStringAsVector InitPropVariantFromStringVector InitPropVariantFromStrRet InitPropVariantFromUInt16Vector InitPropVariantFromUInt32Vector InitPropVariantFromUInt64Vector InitPropVariantVectorFromPropVariant InitVariantFromBooleanArray InitVariantFromBuffer InitVariantFromDoubleArray InitVariantFromFileTime InitVariantFromFileTimeArray InitVariantFromGUIDAsString InitVariantFromInt16Array InitVariantFromInt32Array InitVariantFromInt64Array InitVariantFromResource InitVariantFromStringArray InitVariantFromStrRet InitVariantFromUInt16Array InitVariantFromUInt32Array InitVariantFromUInt64Array InitVariantFromVariantArrayElem IsAccelerator IsEqualGUID LHashValOfNameSys LHashValOfNameSysAA LoadRegTypeLib LoadTypeLib LoadTypeLibEx LPSAFEARRAY_UserFree LPSAFEARRAY_UserFree64 LPSAFEARRAY_UserMarshal LPSAFEARRAY_UserMarshal64 LPSAFEARRAY_UserSize LPSAFEARRAY_UserSize64 LPSAFEARRAY_UserUnmarshal LPSAFEARRAY_UserUnmarshal64 MkParseDisplayName MonikerCommonPrefixWith MonikerRelativePathTo OaBuildVersion OaEnablePerUserTLibRegistration OleConvertIStorageToOLESTREAM OleConvertIStorageToOLESTREAMEx OleConvertOLESTREAMToIStorage OleConvertOLESTREAMToIStorageEx OleCreate OleCreateDefaultHandler OleCreateEmbeddingHelper OleCreateEx OleCreateFontIndirect OleCreateFromData OleCreateFromDataEx OleCreateFromFile OleCreateFromFileEx OleCreateLink OleCreateLinkEx OleCreateLinkFromData OleCreateLinkFromDataEx OleCreateLinkToFile OleCreateLinkToFileEx OleCreateMenuDescriptor OleCreatePictureIndirect OleCreatePropertyFrame OleCreatePropertyFrameIndirect OleCreateStaticFromData OleDestroyMenuDescriptor OleDoAutoConvert OleDraw OleDuplicateData OleFlushClipboard OleGetAutoConvert OleGetClipboard OleGetClipboardWithEnterpriseInfo OleGetIconOfClass OleGetIconOfFile OleIconToCursor OleInitialize OleIsCurrentClipboard OleIsRunning OleLoad OleLoadPicture OleLoadPictureEx OleLoadPictureFile OleLoadPictureFileEx OleLoadPicturePath OleLockRunning OleMetafilePictFromIconAndLabel OleNoteObjectVisible OleQueryCreateFromData OleQueryLinkFromData OleRegEnumFormatEtc OleRegEnumVerbs OleRegGetMiscStatus OleRegGetUserType OleRun OleSave OleSavePictureFile OleSaveToStream OleSetAutoConvert OleSetClipboard OleSetContainedObject OleSetMenuDescriptor OleTranslateAccelerator OleTranslateColor OleUninitialize ProgIDFromCLSID PropStgNameToFmtId PropVariantChangeType PropVariantClear PropVariantCompareEx PropVariantCopy PropVariantGetBooleanElem PropVariantGetDoubleElem PropVariantGetElementCount PropVariantGetFileTimeElem PropVariantGetInt16Elem PropVariantGetInt32Elem PropVariantGetInt64Elem PropVariantGetStringElem PropVariantGetUInt16Elem PropVariantGetUInt32Elem PropVariantGetUInt64Elem PropVariantToBoolean PropVariantToBooleanVector PropVariantToBooleanVectorAlloc PropVariantToBooleanWithDefault PropVariantToBSTR PropVariantToBuffer PropVariantToDouble PropVariantToDoubleVector PropVariantToDoubleVectorAlloc PropVariantToDoubleWithDefault PropVariantToFileTime PropVariantToFileTimeVector PropVariantToFileTimeVectorAlloc PropVariantToGUID PropVariantToInt16 PropVariantToInt16Vector PropVariantToInt16VectorAlloc PropVariantToInt16WithDefault PropVariantToInt32 PropVariantToInt32Vector PropVariantToInt32VectorAlloc PropVariantToInt32WithDefault PropVariantToInt64 PropVariantToInt64Vector PropVariantToInt64VectorAlloc PropVariantToInt64WithDefault PropVariantToString PropVariantToStringAlloc PropVariantToStringVector PropVariantToStringVectorAlloc PropVariantToStringWithDefault PropVariantToStrRet PropVariantToUInt16 PropVariantToUInt16Vector PropVariantToUInt16VectorAlloc PropVariantToUInt16WithDefault PropVariantToUInt32 PropVariantToUInt32Vector PropVariantToUInt32VectorAlloc PropVariantToUInt32WithDefault PropVariantToUInt64 PropVariantToUInt64Vector PropVariantToUInt64VectorAlloc PropVariantToUInt64WithDefault PropVariantToVariant PropVariantToWinRTPropertyValue PSCoerceToCanonicalValue PSCreateAdapterFromPropertyStore PSCreateDelayedMultiplexPropertyStore PSCreateMemoryPropertyStore PSCreateMultiplexPropertyStore PSCreatePropertyChangeArray PSCreatePropertyStoreFromObject PSCreatePropertyStoreFromPropertySetStorage PSCreateSimplePropertyChange PSEnumeratePropertyDescriptions PSFormatForDisplay PSFormatForDisplayAlloc PSFormatPropertyValue PSGetImageReferenceForValue PSGetItemPropertyHandler PSGetItemPropertyHandlerWithCreateObject PSGetNamedPropertyFromPropertyStorage PSGetNameFromPropertyKey PSGetPropertyDescription PSGetPropertyDescriptionByName PSGetPropertyDescriptionListFromString PSGetPropertyFromPropertyStorage PSGetPropertyKeyFromName PSGetPropertySystem PSGetPropertyValue PSLookupPropertyHandlerCLSID PSPropertyBag_Delete PSPropertyBag_ReadBOOL PSPropertyBag_ReadBSTR PSPropertyBag_ReadDWORD PSPropertyBag_ReadGUID PSPropertyBag_ReadInt PSPropertyBag_ReadLONG PSPropertyBag_ReadPOINTL PSPropertyBag_ReadPOINTS PSPropertyBag_ReadPropertyKey PSPropertyBag_ReadRECTL PSPropertyBag_ReadSHORT PSPropertyBag_ReadStr PSPropertyBag_ReadStrAlloc PSPropertyBag_ReadStream PSPropertyBag_ReadType PSPropertyBag_ReadULONGLONG PSPropertyBag_ReadUnknown PSPropertyBag_WriteBOOL PSPropertyBag_WriteBSTR PSPropertyBag_WriteDWORD PSPropertyBag_WriteGUID PSPropertyBag_WriteInt PSPropertyBag_WriteLONG PSPropertyBag_WritePOINTL PSPropertyBag_WritePOINTS PSPropertyBag_WritePropertyKey PSPropertyBag_WriteRECTL PSPropertyBag_WriteSHORT PSPropertyBag_WriteStr PSPropertyBag_WriteStream PSPropertyBag_WriteULONGLONG PSPropertyBag_WriteUnknown PSPropertyKeyFromString PSRefreshPropertySchema PSRegisterPropertySchema PSSetPropertyValue PSStringFromPropertyKey PSUnregisterPropertySchema QueryPathOfRegTypeLib ReadClassStg ReadClassStm ReadFmtUserTypeStg RegisterActiveObject RegisterDragDrop RegisterTypeLib RegisterTypeLibForUser ReleaseStgMedium RevokeActiveObject RevokeDragDrop RoGetAgileReference SafeArrayAccessData SafeArrayAddRef SafeArrayAllocData SafeArrayAllocDescriptor SafeArrayAllocDescriptorEx SafeArrayCopy SafeArrayCopyData SafeArrayCreate SafeArrayCreateEx SafeArrayCreateVector SafeArrayCreateVectorEx SafeArrayDestroy SafeArrayDestroyData SafeArrayDestroyDescriptor SafeArrayGetDim SafeArrayGetElement SafeArrayGetElemsize SafeArrayGetIID SafeArrayGetLBound SafeArrayGetRecordInfo SafeArrayGetUBound SafeArrayGetVartype SafeArrayLock SafeArrayPtrOfIndex SafeArrayPutElement SafeArrayRedim SafeArrayReleaseData SafeArrayReleaseDescriptor SafeArraySetIID SafeArraySetRecordInfo SafeArrayUnaccessData SafeArrayUnlock SetConvertStg SetErrorInfo StgConvertVariantToProperty StgCreateDocfile StgCreateDocfileOnILockBytes StgCreatePropSetStg StgCreatePropStg StgCreateStorageEx StgDeserializePropVariant StgIsStorageFile StgIsStorageILockBytes StgOpenPropStg StgOpenStorage StgOpenStorageEx StgOpenStorageOnILockBytes StgPropertyLengthAsVariant StgSerializePropVariant StgSetTimes StringFromCLSID StringFromGUID2 StringFromIID SysAddRefString SysAllocString SysAllocStringByteLen SysAllocStringLen SysFreeString SysReAllocString SysReAllocStringLen SysReleaseString SysStringByteLen SysStringLen SystemTimeToVariantTime UnRegisterTypeLib UnRegisterTypeLibForUser VarAbs VarAdd VarAnd VarBoolFromCy VarBoolFromDate VarBoolFromDec VarBoolFromDisp VarBoolFromI1 VarBoolFromI2 VarBoolFromI4 VarBoolFromI8 VarBoolFromR4 VarBoolFromR8 VarBoolFromStr VarBoolFromUI1 VarBoolFromUI2 VarBoolFromUI4 VarBoolFromUI8 VarBstrCat VarBstrCmp VarBstrFromBool VarBstrFromCy VarBstrFromDate VarBstrFromDec VarBstrFromDisp VarBstrFromI1 VarBstrFromI2 VarBstrFromI4 VarBstrFromI8 VarBstrFromR4 VarBstrFromR8 VarBstrFromUI1 VarBstrFromUI2 VarBstrFromUI4 VarBstrFromUI8 VarCat VarCmp VarCyAbs VarCyAdd VarCyCmp VarCyCmpR8 VarCyFix VarCyFromBool VarCyFromDate VarCyFromDec VarCyFromDisp VarCyFromI1 VarCyFromI2 VarCyFromI4 VarCyFromI8 VarCyFromR4 VarCyFromR8 VarCyFromStr VarCyFromUI1 VarCyFromUI2 VarCyFromUI4 VarCyFromUI8 VarCyInt VarCyMul VarCyMulI4 VarCyMulI8 VarCyNeg VarCyRound VarCySub VarDateFromBool VarDateFromCy VarDateFromDec VarDateFromDisp VarDateFromI1 VarDateFromI2 VarDateFromI4 VarDateFromI8 VarDateFromR4 VarDateFromR8 VarDateFromStr VarDateFromUdate VarDateFromUdateEx VarDateFromUI1 VarDateFromUI2 VarDateFromUI4 VarDateFromUI8 VarDecAbs VarDecAdd VarDecCmp VarDecCmpR8 VarDecDiv VarDecFix VarDecFromBool VarDecFromCy VarDecFromDate VarDecFromDisp VarDecFromI1 VarDecFromI2 VarDecFromI4 VarDecFromI8 VarDecFromR4 VarDecFromR8 VarDecFromStr VarDecFromUI1 VarDecFromUI2 VarDecFromUI4 VarDecFromUI8 VarDecInt VarDecMul VarDecNeg VarDecRound VarDecSub VarDiv VarEqv VarFix VarFormat VarFormatCurrency VarFormatDateTime VarFormatFromTokens VarFormatNumber VarFormatPercent VarI1FromBool VarI1FromCy VarI1FromDate VarI1FromDec VarI1FromDisp VarI1FromI2 VarI1FromI4 VarI1FromI8 VarI1FromR4 VarI1FromR8 VarI1FromStr VarI1FromUI1 VarI1FromUI2 VarI1FromUI4 VarI1FromUI8 VarI2FromBool VarI2FromCy VarI2FromDate VarI2FromDec VarI2FromDisp VarI2FromI1 VarI2FromI4 VarI2FromI8 VarI2FromR4 VarI2FromR8 VarI2FromStr VarI2FromUI1 VarI2FromUI2 VarI2FromUI4 VarI2FromUI8 VarI4FromBool VarI4FromCy VarI4FromDate VarI4FromDec VarI4FromDisp VarI4FromI1 VarI4FromI2 VarI4FromI8 VarI4FromR4 VarI4FromR8 VarI4FromStr VarI4FromUI1 VarI4FromUI2 VarI4FromUI4 VarI4FromUI8 VarI8FromBool VarI8FromCy VarI8FromDate VarI8FromDec VarI8FromDisp VarI8FromI1 VarI8FromI2 VarI8FromR4 VarI8FromR8 VarI8FromStr VarI8FromUI1 VarI8FromUI2 VarI8FromUI4 VarI8FromUI8 VARIANT_UserFree VARIANT_UserFree64 VARIANT_UserMarshal VARIANT_UserMarshal64 VARIANT_UserSize VARIANT_UserSize64 VARIANT_UserUnmarshal VARIANT_UserUnmarshal64 VariantChangeType VariantChangeTypeEx VariantClear VariantCompare VariantCopy VariantCopyInd VariantGetBooleanElem VariantGetDoubleElem VariantGetElementCount VariantGetInt16Elem VariantGetInt32Elem VariantGetInt64Elem VariantGetStringElem VariantGetUInt16Elem VariantGetUInt32Elem VariantGetUInt64Elem VariantInit VariantTimeToDosDateTime VariantTimeToSystemTime VariantToBoolean VariantToBooleanArray VariantToBooleanArrayAlloc VariantToBooleanWithDefault VariantToBuffer VariantToDosDateTime VariantToDouble VariantToDoubleArray VariantToDoubleArrayAlloc VariantToDoubleWithDefault VariantToFileTime VariantToGUID VariantToInt16 VariantToInt16Array VariantToInt16ArrayAlloc VariantToInt16WithDefault VariantToInt32 VariantToInt32Array VariantToInt32ArrayAlloc VariantToInt32WithDefault VariantToInt64 VariantToInt64Array VariantToInt64ArrayAlloc VariantToInt64WithDefault VariantToPropVariant VariantToString VariantToStringAlloc VariantToStringArray VariantToStringArrayAlloc VariantToStringWithDefault VariantToStrRet VariantToUInt16 VariantToUInt16Array VariantToUInt16ArrayAlloc VariantToUInt16WithDefault VariantToUInt32 VariantToUInt32Array VariantToUInt32ArrayAlloc VariantToUInt32WithDefault VariantToUInt64 VariantToUInt64Array VariantToUInt64ArrayAlloc VariantToUInt64WithDefault VarIdiv VarImp VarInt VarMod VarMonthName VarMul VarNeg VarNot VarNumFromParseNum VarOr VarParseNumFromStr VarPow VarR4CmpR8 VarR4FromBool VarR4FromCy VarR4FromDate VarR4FromDec VarR4FromDisp VarR4FromI1 VarR4FromI2 VarR4FromI4 VarR4FromI8 VarR4FromR8 VarR4FromStr VarR4FromUI1 VarR4FromUI2 VarR4FromUI4 VarR4FromUI8 VarR8FromBool VarR8FromCy VarR8FromDate VarR8FromDec VarR8FromDisp VarR8FromI1 VarR8FromI2 VarR8FromI4 VarR8FromI8 VarR8FromR4 VarR8FromStr VarR8FromUI1 VarR8FromUI2 VarR8FromUI4 VarR8FromUI8 VarR8Pow VarR8Round VarRound VarSub VarTokenizeFormatString VarUdateFromDate VarUI1FromBool VarUI1FromCy VarUI1FromDate VarUI1FromDec VarUI1FromDisp VarUI1FromI1 VarUI1FromI2 VarUI1FromI4 VarUI1FromI8 VarUI1FromR4 VarUI1FromR8 VarUI1FromStr VarUI1FromUI2 VarUI1FromUI4 VarUI1FromUI8 VarUI2FromBool VarUI2FromCy VarUI2FromDate VarUI2FromDec VarUI2FromDisp VarUI2FromI1 VarUI2FromI2 VarUI2FromI4 VarUI2FromI8 VarUI2FromR4 VarUI2FromR8 VarUI2FromStr VarUI2FromUI1 VarUI2FromUI4 VarUI2FromUI8 VarUI4FromBool VarUI4FromCy VarUI4FromDate VarUI4FromDec VarUI4FromDisp VarUI4FromI1 VarUI4FromI2 VarUI4FromI4 VarUI4FromI8 VarUI4FromR4 VarUI4FromR8 VarUI4FromStr VarUI4FromUI1 VarUI4FromUI2 VarUI4FromUI8 VarUI8FromBool VarUI8FromCy VarUI8FromDate VarUI8FromDec VarUI8FromDisp VarUI8FromI1 VarUI8FromI2 VarUI8FromI8 VarUI8FromR4 VarUI8FromR8 VarUI8FromStr VarUI8FromUI1 VarUI8FromUI2 VarUI8FromUI4 VarWeekdayName VarXor VectorFromBstr WinRTPropertyValueToPropVariant WriteClassStg WriteClassStm WriteFmtUserTypeStg  | AgileReferenceOptions COWAIT_FLAGS CWMO_FLAGS REGCLS STDMSHLFLAGS DOCMISC IGNOREMIME MEDIAPLAYBACK_STATE OLECMDEXECOPT OLECMDF OLECMDID OLECMDID_WINDOWSTATE_FLAG OLECMDTEXTF PRINTFLAG WPCSETTING TrustLevel APTTYPE APTTYPEQUALIFIER CLSCTX COINIT COMSD STGFMT ACTIVATIONTYPE ApplicationType BIND_FLAGS CALLTYPE PENDINGMSG PENDINGTYPE ROTFLAGS SERVERCALL ShutdownType STGTY CO_MARSHALING_CONTEXT_ATTRIBUTES EOLE_AUTHENTICATION_CAPABILITIES EXTCONN GLOBALOPT_PROPERTIES LOCKTYPE RPCOPT_PROPERTIES RPCOPT_SERVER_LOCALITY_VALUES STREAM_SEEK THDTYPE INTERFACEUSE ACTIVATEFLAGS CTRLINFO DVASPECT2 DVASPECTINFOFLAG DVEXTENTMODE GUIDKIND HITRESULT KEYMODIFIERS MULTICLASSINFO OLEDCFLAGS PICTUREATTRIBUTES PICTYPE POINTERINACTIVE PROPPAGESTATUS QACONTAINERFLAGS READYSTATE UASFLAGS VIEWSTATUS XFORMCOORDS EMBDHLP OLECREATE DISCARDCACHE DROPEFFECT OLECLOSE OLECONTF OLEGETMONIKER OLELINKBIND OLEMISC OLERENDER OLEUPDATE OLEVERBATTRIB OLEWHICHMK UPDFCACHE USERCLASSTYPE PROPSETFLAG PRSPEC RECORD_READING_POLICY MSHCTX MSHLFLAGS STATFLAG STGC STGMOVE TYSPEC VARTYPE CALLCONV CHANGEKIND PROPBAG2_TYPE VarChangeFlag VarFlags VtBits DispInvokeFlags REGKIND ADVFEATUREFLAGS LoadPictureFlag PICTYPE IT_MSG IT_STATUS WIA_PROPID WiaDevCap WiaDevDlg WiaImageIntent WiaItemType GETPROPERTYSTOREFLAGS PERSIST_SPROPSTORE_FLAGS CONDITION_OPERATION PROPDESC_AGGREGATION_TYPE PROPDESC_CONDITION_TYPE PROPDESC_DISPLAYTYPE PROPDESC_ENUMFILTER PROPDESC_FORMAT_FLAGS PROPDESC_GROUPING_RANGE PROPDESC_RELATIVEDESCRIPTION_TYPE PROPDESC_SORTDESCRIPTION PROPDESC_TYPE_FLAGS PROPDESC_VIEW_FLAGS PROPENUMTYPE STOREID PKA_FLAGS PROPVAR_CHANGE_FLAGS PROPVAR_COMPARE_FLAGS PROPVAR_COMPARE_UNIT PSTIME_FLAGS SHCOLSTATE                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       | ServerInformation CATEGORYINFO ComCallData OLECMD OLECMDTEXT PAGERANGE PAGESET CO_MTA_USAGE_COOKIE STGOPTIONS COSERVERINFO ContextProperty DVTARGETDEVICE StorageLayout BIND_OPTS_V BIND_OPTS2 BIND_OPTS3 INTERFACEINFO SNB MULTI_QI RPCOLEMESSAGE SOLE_AUTHENTICATION_INFO SOLE_AUTHENTICATION_LIST SOLE_AUTHENTICATION_SERVICE CADWORD CALPOLESTR CAUUID CONNECTDATA CONTROLINFO DVASPECTINFO DVEXTENTINFO LICINFO POINTF PROPPAGEINFO QACONTAINER QACONTROL HOLEMENU OLESTREAM OLEINPLACEFRAMEINFO OLEMENUGROUPWIDTHS OLEVERB PROPSPEC STATPROPSETSTG STATPROPSTG BLOB CLIPDATA PACKEDMETA PROPVARIANT PROPVARIANT_IMMUTABLE CSPLATFORM QUERYCONTEXT uCLSSPEC PROPERTYKEY ARRAYDESC CUSTDATA CUSTDATAITEM PARAMDESCEX PROPBAG2 VARIANT INTERFACEDATA METHODDATA NUMPARSE PARAMDATA UDATE SAFEARRAY SAFEARRAYBOUND FONTDESC OCPFIPARAMS PICTDESC WIA_DATA_CALLBACK_HEADER WIA_DATA_TRANSFER_INFO WIA_DEV_CAP WIA_DITHER_PATTERN_DATA WIA_EXTENDED_TRANSFER_INFO WIA_FORMAT_INFO SpecUnion PICTDEC_UNION BYNAME BYOBJECTID BMP WMF ICON EMF                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  | ICatInformation ICatRegister IEnumCATEGORYINFO IEnumGUID IContextCallback IContinueCallback IEnumOleDocumentViews IOleCommandTarget IOleDocument IOleDocumentSite IOleDocumentView IPrint IProtectedModeMenuServices IProtectFocus IZoomEvents IAccessControl IInspectable IMessageDispatcher IAdviseSink2 IAgileObject IAgileReference IBindCtxV IBlockingLock IClassActivator IDataAdviseHolder IDirectWriterLock IEnumSTATSTG IEnumUnknown IFillLockBytes IForegroundTransfer IInitializeSpy ILayoutStorage ILockBytes IMallocSpy IMessageFilter IPersist IPersistStorage IPersistStream IProcessLock IProgressNotify IROTData IRunnableObject IRunningObjectTable IStorage ISurrogateService IActivationFilter ICallFactory ICancelMethodCalls IChannelHook IClientSecurity IComThreadingInfo IContext IEnumContextProps IEnumStringV IExternalConnection IFastRundown IGlobalInterfaceTable IGlobalOptions IInternalUnknown IMalloc IMarshal IMarshalingStream IMultiQI INoMarshal IObjContext IProcessInitControl IPSFactoryBuffer IRpcChannelBuffer IRpcOptions IRpcProxyBuffer IRpcStubBuffer ISequentialStream IServerSecurity IStdMarshalInfo IStreamV ISurrogate ISynchronize ISynchronizeContainer ISynchronizeEvent ISynchronizeHandle IObjectSafety IAdviseSinkEx IClassFactory2 IEnumOleUndoUnits IFont IObjectWithSite IOleControl IOleControlSite IOleInPlaceObjectWindowless IOleInPlaceSiteEx IOleInPlaceSiteWindowless IOleParentUndoUnit IOleUndoManager IOleUndoUnit IPerPropertyBrowsing IPersistPropertyBag IPersistStreamInit IPicture IPicture2 IPointerInactive IPropertyNotifySink IPropertyPage IPropertyPage2 IPropertyPageSite IProvideClassInfo IProvideClassInfo2 IProvideMultipleClassInfo IQuickActivate ISimpleFrameSite ISpecifyPropertyPages IViewObjectEx IDropSource IDropSourceNotify IDropTarget IEnterpriseDropTarget IEnumOLEVERB IOleAdviseHolder IOleCache IOleCache2 IOleCacheControl IOleClientSite IOleContainer IOleInPlaceActiveObject IOleInPlaceFrame IOleInPlaceObject IOleInPlaceSite IOleInPlaceUIWindow IOleLink IOleObject IOleWindow IParseDisplayName IViewObject IViewObject2 IEnumSTATPROPSETSTG IEnumSTATPROPSTG IPropertySetStorage IPropertyStorage IFileBasedLogInit ILog IClassFactory ICreateErrorInfo ICreateTypeInfo ICreateTypeInfo2 ICreateTypeLib ICreateTypeLib2 IDispatch IErrorInfo IErrorLog IPropertyBag IPropertyBag2 IRecordInfo ISupportErrorInfo ITypeChangeEvents IEnumWIA_DEV_CAPS IEnumWIA_DEV_INFO IEnumWIA_FORMAT_INFO IEnumWiaItem IWiaDataCallback IWiaDataTransfer IWiaDevMgr IWiaEventCallback IWiaItem IWiaItemExtras IWiaPropertyStorage ICreateObject IDelayedPropertyStoreFactory IInitializeWithStream IPersistSerializedPropStorage IPropertyDescription IPropertyDescription2 IPropertyDescriptionList IPropertyEnumType IPropertyEnumType2 IPropertyEnumTypeList IPropertyStore IPropertyStoreCapabilities IPropertyStoreFactory IPropertySystem IObjectWithPropertyKey IPropertyChange IPropertyChangeArray                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
